/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "sg.y"


/*
 * ufdbGuard is copyrighted (C) 2005-2015 by URLfilterDB with all rights reserved.
 *
 * Parts of the ufdbGuard daemon are based on squidGuard.
 * squidGuard is copyrighted (C) 1998 by
 * ElTele st AS, Oslo, Norway, with all rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License (version 2) as
 * published by the Free Software Foundation.  It is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License (GPL) for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * (GPL2) along with this program.
 */

#define YYMALLOC  ufdbMalloc
#define YYFREE    ufdbFree

#define UFDB_LOG_USER_QUOTA   0   /* TODO remove */

#undef UFDB_DEBUG_ACL_ACCESS

#include "ufdb.h"
#include "sg.h"
#include "ufdblib.h"
#include "ufdbdb.h"
#include "ufdbchkport.h"

#ifdef UFDB_DEBUG
#undef YYDEBUG
#define YYDEBUG 1
#endif

#define UFDB_TIME_DEBUG 0

#include <pthread.h>
#include <sys/types.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <netdb.h>
#include <grp.h>
#include <syslog.h>
#include <signal.h>
#include <sched.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <unistd.h>

#ifdef UFDB_HAVE_NATIVE_RWLOCK_MUTEX
pthread_rwlock_t  TheDynamicSourcesLock = PTHREAD_RWLOCK_INITIALIZER;
pthread_rwlock_t  TheDynamicCategoriesLock = PTHREAD_RWLOCK_INITIALIZER;
#else
pthread_mutex_t   TheDynamicSourcesLock = UFDB_STATIC_MUTEX_INIT;
pthread_mutex_t   TheDynamicCategoriesLock = UFDB_STATIC_MUTEX_INIT;
#endif


FILE * yyin;
FILE * yyout;
int    lineno;

extern struct ufdbSetting * lastSetting;
extern struct ufdbSetting * Setting;

extern struct Source * lastSource;

extern struct Category * lastCat;
extern struct Category * Cat;

extern struct sgRewrite * lastRewrite;
extern struct sgRewrite * Rewrite;
extern struct ufdbRegExp *  lastRewriteRegExec;

extern struct ufdbTime * lastTime;
extern struct ufdbTime * TimeList;

extern struct LogFile * globalLogFile;

extern struct LogFileStat * lastLogFileStat;
extern struct LogFileStat * LogFileStat;

extern struct TimeElement * lastTimeElement;
extern struct TimeElement * TimeElement;

extern struct Acl * lastAcl;
extern struct Acl * defaultAcl;
extern struct Aclcategory * lastAclcategory;
 
extern struct ufdbRegExp * lastRegExpDest;

extern int    httpsConnectionCacheSize;

extern int    globalDebugTimeDelta;

static int   numTimeElements = 0;
static int * TimeElementsEvents = NULL;

static int   time_switch = 0;
static int   date_switch = 0;

static void setRefreshUserlist( int nmin );
static void setRefreshDomainlist( int nmin );
static void ufdbSourceGroup( int groupType, char * groupName );
static void ufdbSourceUserQuota( char * seconds, char * sporadic, char * renew );
void ufdbFreeDomainDb( struct sgDb * dbp );


/* Line 371 of yacc.c  */
#line 182 "y.tab.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ADMINISTRATOR = 258,
     QSTRING = 259,
     CHECK_PROXY_TUNNELS = 260,
     QUEUE_CHECKS = 261,
     AGGRESSIVE = 262,
     LOG_ONLY = 263,
     ON = 264,
     OFF = 265,
     CHAR_MINUS = 266,
     CHAR_I = 267,
     CHAR_EXCLAMATION = 268,
     IGNORECASE = 269,
     COMMA = 270,
     EQUAL = 271,
     PORT = 272,
     HTTP_SERVER = 273,
     INTERFACE = 274,
     IMAGES = 275,
     HTTPS_PROHIBIT_INSECURE_SSLV2 = 276,
     HTTPS_CONNECTION_CACHE_SIZE = 277,
     IDENTIFIER = 278,
     WORD = 279,
     END = 280,
     START_BRACKET = 281,
     STOP_BRACKET = 282,
     WEEKDAY = 283,
     CATEGORY = 284,
     REWRITE = 285,
     ACL = 286,
     CPUS = 287,
     TIME = 288,
     TVAL = 289,
     DVAL = 290,
     DVALCRON = 291,
     SOURCE = 292,
     CIDR = 293,
     IPCLASS = 294,
     CONTINUE = 295,
     IPADDR = 296,
     DBHOME = 297,
     DOMAINLIST = 298,
     EXECDOMAINLIST = 299,
     REFRESHDOMAINLIST = 300,
     URLLIST = 301,
     EXPRESSIONLIST = 302,
     CACERTS = 303,
     CACERTSDIR = 304,
     IPLIST = 305,
     DOMAIN = 306,
     UNIX = 307,
     LDAP = 308,
     USER = 309,
     USERLIST = 310,
     EXECUSERLIST = 311,
     REFRESHUSERLIST = 312,
     USERQUOTA = 313,
     GROUP = 314,
     IP = 315,
     NL = 316,
     NUMBER = 317,
     NUMBERS = 318,
     PASS = 319,
     REDIRECT = 320,
     SUBST = 321,
     CHAR = 322,
     MINUTELY = 323,
     HOURLY = 324,
     DAILY = 325,
     WEEKLY = 326,
     DATE = 327,
     REDIRECT_FATAL_ERROR = 328,
     REDIRECT_LOADING_DATABASE = 329,
     REDIRECT_HTTPS = 330,
     WITHIN = 331,
     OUTSIDE = 332,
     ELSE = 333,
     ANONYMOUS = 334,
     SPORADIC = 335,
     LOGFILE = 336,
     LOGDIR = 337,
     LOGPASS = 338,
     LOGBLOCK = 339,
     LOGALL = 340,
     LOGALL_HTTPD = 341,
     MAIL_SERVER = 342,
     ADMIN_EMAIL = 343,
     EXTERNAL_STATUS_COMMAND = 344,
     TOKEN_ALLOW = 345,
     TOKEN_DENY = 346,
     YOUTUBE_EDUFILTER = 347,
     YOUTUBE_EDUFILTER_ID = 348,
     ALLOW_GOOGLE_HTTPS_USING_IP = 349,
     URL_LOOKUP_RESULT_DB_RELOAD = 350,
     URL_LOOKUP_RESULT_FATAL_ERROR = 351,
     URL_LOOKUP_DELAY_DB_RELOAD = 352,
     OPTION = 353,
     UFDB_SHOW_URL_DETAILS = 354,
     SQUID_VERSION = 355,
     SQUID_USES_SSL_BUMP = 356,
     STRIP_DOMAIN_FROM_USERNAME = 357,
     UFDB_DEBUG_FILTER = 358,
     UFDB_DEBUG_SKYPE_PROBES = 359,
     UFDB_DEBUG_GTALK_PROBES = 360,
     UFDB_DEBUG_YAHOOMSG_PROBES = 361,
     UFDB_DEBUG_AIM_PROBES = 362,
     UFDB_DEBUG_FBCHAT_PROBES = 363,
     UFDB_DEBUG_CITRIXONLINE_PROBES = 364,
     UFDB_EXPRESSION_OPTIMISATION = 365,
     UFDB_EXPRESSION_DEBUG = 366,
     UFDB_DEBUG_EXTERNAL_SCRIPTS = 367,
     UFDB_NUM_WORKER_THREADS = 368,
     ENFORCE_HTTPS_WITH_HOSTNAME = 369,
     ENFORCE_HTTPS_OFFICAL_CERTIFICATE = 370,
     ALLOW_SKYPE_OVER_HTTPS = 371,
     ALLOW_UNKNOWN_PROTOCOL_OVER_HTTPS = 372,
     ALLOW_GTALK_OVER_HTTPS = 373,
     ALLOW_YAHOOMSG_OVER_HTTPS = 374,
     ALLOW_AIM_OVER_HTTPS = 375,
     ALLOW_FBCHAT_OVER_HTTPS = 376,
     ALLOW_CITRIXONLINE_OVER_HTTPS = 377,
     ANALYSE_UNCATEGORISED = 378,
     LOG_UNCATEGORISED_URLS = 379,
     UPLOAD_STATS = 380,
     SAFE_SEARCH = 381,
     MAX_LOGFILE_SIZE = 382
   };
#endif
/* Tokens.  */
#define ADMINISTRATOR 258
#define QSTRING 259
#define CHECK_PROXY_TUNNELS 260
#define QUEUE_CHECKS 261
#define AGGRESSIVE 262
#define LOG_ONLY 263
#define ON 264
#define OFF 265
#define CHAR_MINUS 266
#define CHAR_I 267
#define CHAR_EXCLAMATION 268
#define IGNORECASE 269
#define COMMA 270
#define EQUAL 271
#define PORT 272
#define HTTP_SERVER 273
#define INTERFACE 274
#define IMAGES 275
#define HTTPS_PROHIBIT_INSECURE_SSLV2 276
#define HTTPS_CONNECTION_CACHE_SIZE 277
#define IDENTIFIER 278
#define WORD 279
#define END 280
#define START_BRACKET 281
#define STOP_BRACKET 282
#define WEEKDAY 283
#define CATEGORY 284
#define REWRITE 285
#define ACL 286
#define CPUS 287
#define TIME 288
#define TVAL 289
#define DVAL 290
#define DVALCRON 291
#define SOURCE 292
#define CIDR 293
#define IPCLASS 294
#define CONTINUE 295
#define IPADDR 296
#define DBHOME 297
#define DOMAINLIST 298
#define EXECDOMAINLIST 299
#define REFRESHDOMAINLIST 300
#define URLLIST 301
#define EXPRESSIONLIST 302
#define CACERTS 303
#define CACERTSDIR 304
#define IPLIST 305
#define DOMAIN 306
#define UNIX 307
#define LDAP 308
#define USER 309
#define USERLIST 310
#define EXECUSERLIST 311
#define REFRESHUSERLIST 312
#define USERQUOTA 313
#define GROUP 314
#define IP 315
#define NL 316
#define NUMBER 317
#define NUMBERS 318
#define PASS 319
#define REDIRECT 320
#define SUBST 321
#define CHAR 322
#define MINUTELY 323
#define HOURLY 324
#define DAILY 325
#define WEEKLY 326
#define DATE 327
#define REDIRECT_FATAL_ERROR 328
#define REDIRECT_LOADING_DATABASE 329
#define REDIRECT_HTTPS 330
#define WITHIN 331
#define OUTSIDE 332
#define ELSE 333
#define ANONYMOUS 334
#define SPORADIC 335
#define LOGFILE 336
#define LOGDIR 337
#define LOGPASS 338
#define LOGBLOCK 339
#define LOGALL 340
#define LOGALL_HTTPD 341
#define MAIL_SERVER 342
#define ADMIN_EMAIL 343
#define EXTERNAL_STATUS_COMMAND 344
#define TOKEN_ALLOW 345
#define TOKEN_DENY 346
#define YOUTUBE_EDUFILTER 347
#define YOUTUBE_EDUFILTER_ID 348
#define ALLOW_GOOGLE_HTTPS_USING_IP 349
#define URL_LOOKUP_RESULT_DB_RELOAD 350
#define URL_LOOKUP_RESULT_FATAL_ERROR 351
#define URL_LOOKUP_DELAY_DB_RELOAD 352
#define OPTION 353
#define UFDB_SHOW_URL_DETAILS 354
#define SQUID_VERSION 355
#define SQUID_USES_SSL_BUMP 356
#define STRIP_DOMAIN_FROM_USERNAME 357
#define UFDB_DEBUG_FILTER 358
#define UFDB_DEBUG_SKYPE_PROBES 359
#define UFDB_DEBUG_GTALK_PROBES 360
#define UFDB_DEBUG_YAHOOMSG_PROBES 361
#define UFDB_DEBUG_AIM_PROBES 362
#define UFDB_DEBUG_FBCHAT_PROBES 363
#define UFDB_DEBUG_CITRIXONLINE_PROBES 364
#define UFDB_EXPRESSION_OPTIMISATION 365
#define UFDB_EXPRESSION_DEBUG 366
#define UFDB_DEBUG_EXTERNAL_SCRIPTS 367
#define UFDB_NUM_WORKER_THREADS 368
#define ENFORCE_HTTPS_WITH_HOSTNAME 369
#define ENFORCE_HTTPS_OFFICAL_CERTIFICATE 370
#define ALLOW_SKYPE_OVER_HTTPS 371
#define ALLOW_UNKNOWN_PROTOCOL_OVER_HTTPS 372
#define ALLOW_GTALK_OVER_HTTPS 373
#define ALLOW_YAHOOMSG_OVER_HTTPS 374
#define ALLOW_AIM_OVER_HTTPS 375
#define ALLOW_FBCHAT_OVER_HTTPS 376
#define ALLOW_CITRIXONLINE_OVER_HTTPS 377
#define ANALYSE_UNCATEGORISED 378
#define LOG_UNCATEGORISED_URLS 379
#define UPLOAD_STATS 380
#define SAFE_SEARCH 381
#define MAX_LOGFILE_SIZE 382



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 115 "sg.y"

  char * string;
  char * tval;
  char * dval;
  char * dvalcron;
  int    integer;


/* Line 387 of yacc.c  */
#line 488 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE yylval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_YY_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 516 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   434

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  128
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  102
/* YYNRULES -- Number of rules.  */
#define YYNRULES  293
/* YYNRULES -- Number of states.  */
#define YYNSTATES  433

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   382

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,     9,    12,    14,    16,    18,
      20,    23,    26,    29,    32,    35,    38,    41,    44,    47,
      50,    53,    56,    58,    60,    62,    64,    67,    70,    73,
      76,    79,    82,    85,    88,    91,    94,    97,   100,   103,
     106,   109,   112,   115,   118,   121,   124,   127,   130,   133,
     136,   139,   142,   145,   148,   151,   154,   157,   160,   163,
     166,   169,   172,   175,   178,   181,   184,   188,   192,   196,
     200,   204,   208,   212,   214,   219,   222,   225,   230,   231,
     234,   237,   240,   243,   246,   249,   252,   255,   258,   261,
     264,   268,   272,   276,   280,   283,   286,   289,   292,   295,
     298,   301,   304,   307,   310,   314,   318,   321,   325,   328,
     332,   336,   340,   344,   348,   352,   356,   360,   364,   368,
     372,   375,   378,   381,   386,   387,   390,   393,   396,   400,
     403,   406,   410,   414,   417,   420,   423,   427,   431,   436,
     441,   446,   451,   454,   457,   460,   463,   466,   470,   474,
     477,   480,   482,   483,   486,   489,   492,   493,   496,   499,
     502,   507,   508,   511,   514,   519,   524,   528,   529,   538,
     539,   542,   545,   548,   551,   554,   557,   561,   565,   568,
     571,   572,   575,   578,   582,   586,   589,   591,   593,   594,
     597,   601,   605,   610,   613,   615,   618,   621,   626,   627,
     630,   632,   635,   638,   642,   646,   649,   652,   655,   660,
     661,   664,   665,   666,   672,   673,   674,   680,   681,   682,
     688,   689,   693,   695,   696,   702,   706,   709,   711,   716,
     720,   723,   725,   727,   729,   731,   733,   734,   737,   739,
     741,   743,   745,   747,   749,   751,   753,   755,   757,   759,
     761,   763,   765,   767,   769,   771,   773,   775,   777,   779,
     781,   783,   785,   787,   789,   791,   793,   795,   797,   799,
     801,   803,   805,   807,   809,   811,   813,   815,   817,   819,
     821,   823,   825,   827,   829,   831,   833,   835,   837,   839,
     841,   843,   845,   847
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     129,     0,    -1,   228,    -1,    23,    -1,     4,    -1,    22,
      62,    -1,    90,    -1,    91,    -1,     9,    -1,    10,    -1,
      83,   133,    -1,    84,   133,    -1,    85,   133,    -1,    86,
     133,    -1,    92,   133,    -1,    93,     4,    -1,    94,   133,
      -1,   103,   133,    -1,   103,    62,    -1,   114,   133,    -1,
     115,   133,    -1,    21,   133,    -1,    10,    -1,     6,    -1,
       7,    -1,     8,    -1,     5,   145,    -1,     3,     4,    -1,
      42,   130,    -1,    42,    24,    -1,    57,    62,    -1,    45,
      62,    -1,    95,   132,    -1,    96,   132,    -1,    97,   133,
      -1,   100,     4,    -1,    99,   133,    -1,   104,   133,    -1,
     105,   133,    -1,   106,   133,    -1,   107,   133,    -1,   108,
     133,    -1,   109,   133,    -1,   110,   133,    -1,   111,   133,
      -1,   112,   133,    -1,    87,     4,    -1,    88,     4,    -1,
      89,     4,    -1,    82,   130,    -1,    82,    24,    -1,    17,
      62,    -1,    19,   130,    -1,    19,    41,    -1,    32,    62,
      -1,    32,    63,    -1,   125,   133,    -1,    75,     4,    -1,
      74,     4,    -1,    73,     4,    -1,   124,   133,    -1,   123,
     133,    -1,   123,    62,    -1,   102,   133,    -1,   126,   133,
      -1,   127,    62,    -1,    17,    16,    62,    -1,    19,    16,
     130,    -1,    19,    16,    24,    -1,    19,    16,    41,    -1,
      20,    16,   130,    -1,    20,    16,    24,    -1,   181,    15,
     182,    -1,   181,    -1,    18,    26,   182,    27,    -1,    29,
     130,    -1,    29,     7,    -1,   184,    26,   186,    27,    -1,
      -1,   186,   187,    -1,    43,   130,    -1,    43,    24,    -1,
      43,    11,    -1,    44,   130,    -1,    46,   130,    -1,    46,
      24,    -1,    46,    11,    -1,    47,   130,    -1,    47,    24,
      -1,    47,    11,    -1,    47,    12,   130,    -1,    47,    12,
      24,    -1,    47,    14,   130,    -1,    47,    14,    24,    -1,
      48,   130,    -1,    48,    24,    -1,    49,   130,    -1,    49,
      24,    -1,    65,   130,    -1,    65,    24,    -1,    30,   130,
      -1,    30,    24,    -1,    76,   130,    -1,    77,   130,    -1,
      98,   126,   133,    -1,    98,    92,   133,    -1,    98,   114,
      -1,    98,   114,   133,    -1,    98,   115,    -1,    98,   115,
     133,    -1,    98,    21,   133,    -1,    98,   116,   133,    -1,
      98,   118,   133,    -1,    98,   119,   133,    -1,    98,   120,
     133,    -1,    98,   121,   133,    -1,    98,   122,   133,    -1,
      98,   117,   133,    -1,    81,    79,   130,    -1,    81,    79,
      24,    -1,    81,   130,    -1,    81,    24,    -1,    37,   130,
      -1,   188,    26,   190,    27,    -1,    -1,   190,   191,    -1,
      51,   192,    -1,    54,   193,    -1,    52,    54,   193,    -1,
      55,   130,    -1,    55,    24,    -1,    52,    55,   130,    -1,
      52,    55,    24,    -1,    56,   130,    -1,    59,   130,    -1,
      59,    24,    -1,    52,    59,   130,    -1,    52,    59,    24,
      -1,    58,    62,    62,    69,    -1,    58,    62,    62,    70,
      -1,    58,    62,    62,    71,    -1,    58,    62,    62,    62,
      -1,    60,   204,    -1,    50,   130,    -1,    50,    24,    -1,
      76,   130,    -1,    77,   130,    -1,    81,    79,   130,    -1,
      81,    79,    24,    -1,    81,   130,    -1,    81,    24,    -1,
      40,    -1,    -1,   192,   130,    -1,   192,    24,    -1,   192,
      15,    -1,    -1,   193,   130,    -1,   193,    24,    -1,   193,
      15,    -1,    31,    26,   195,    27,    -1,    -1,   195,   197,
      -1,   130,    26,    -1,   130,    76,   130,    26,    -1,   130,
      77,   130,    26,    -1,   196,   199,    27,    -1,    -1,   196,
     199,    27,    78,   198,    26,   199,    27,    -1,    -1,   199,
     200,    -1,    64,   201,    -1,    30,   130,    -1,    30,    24,
      -1,    65,   130,    -1,    65,    24,    -1,    81,    79,   130,
      -1,    81,    79,    24,    -1,    81,   130,    -1,    81,    24,
      -1,    -1,   201,     7,    -1,   201,   130,    -1,   201,    13,
       7,    -1,   201,    13,   130,    -1,   201,    15,    -1,    38,
      -1,    39,    -1,    -1,   204,   205,    -1,   204,   205,   202,
      -1,   204,   205,   203,    -1,   204,   205,    11,   205,    -1,
     204,    15,    -1,    41,    -1,    30,   130,    -1,    30,    24,
      -1,   206,    26,   208,    27,    -1,    -1,   208,   209,    -1,
      66,    -1,    76,   130,    -1,    77,   130,    -1,    81,    79,
     130,    -1,    81,    79,    24,    -1,    81,   130,    -1,    81,
      24,    -1,    33,   130,    -1,   210,    26,   212,    27,    -1,
      -1,   212,   213,    -1,    -1,    -1,    71,   214,    28,   215,
     221,    -1,    -1,    -1,    71,   216,   130,   217,   221,    -1,
      -1,    -1,    71,   218,    24,   219,   221,    -1,    -1,    72,
     220,   223,    -1,     1,    -1,    -1,   221,   222,   225,    11,
     225,    -1,   225,    11,   225,    -1,   224,   221,    -1,   224,
      -1,   224,    11,   224,   221,    -1,   224,    11,   224,    -1,
     226,   221,    -1,   226,    -1,    35,    -1,    34,    -1,    36,
      -1,     1,    -1,    -1,   228,   229,    -1,   184,    -1,   189,
      -1,   185,    -1,   183,    -1,   147,    -1,   131,    -1,   146,
      -1,   134,    -1,   135,    -1,   136,    -1,   137,    -1,   141,
      -1,   142,    -1,   143,    -1,   144,    -1,   148,    -1,   168,
      -1,   165,    -1,   166,    -1,   167,    -1,   153,    -1,   151,
      -1,   152,    -1,   154,    -1,   155,    -1,   156,    -1,   157,
      -1,   158,    -1,   159,    -1,   160,    -1,   161,    -1,   162,
      -1,   163,    -1,   149,    -1,   150,    -1,   164,    -1,   170,
      -1,   169,    -1,   171,    -1,   172,    -1,   173,    -1,   174,
      -1,   175,    -1,   177,    -1,   176,    -1,   179,    -1,   178,
      -1,   138,    -1,   140,    -1,   139,    -1,   180,    -1,   194,
      -1,   207,    -1,   211,    -1,    61,    -1,   227,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   193,   193,   197,   198,   202,   206,   207,   211,   212,
     216,   220,   224,   228,   232,   236,   240,   244,   245,   249,
     254,   259,   265,   266,   267,   268,   272,   276,   280,   281,
     285,   289,   293,   297,   301,   305,   310,   314,   318,   322,
     326,   330,   334,   338,   342,   346,   350,   354,   358,   362,
     363,   367,   371,   382,   386,   387,   391,   396,   401,   406,
     411,   418,   426,   439,   446,   451,   463,   464,   470,   476,
     477,   478,   482,   483,   487,   491,   492,   497,   501,   502,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   546,
     548,   550,   555,   559,   562,   564,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   582,
     584,   586,   588,   589,   590,   591,   592,   593,   595,   597,
     599,   601,   605,   607,   608,   609,   612,   614,   615,   616,
     620,   623,   624,   628,   629,   630,   634,   636,   635,   640,
     642,   646,   647,   648,   649,   650,   651,   653,   655,   657,
     661,   663,   664,   665,   666,   667,   671,   675,   678,   680,
     681,   682,   683,   684,   688,   692,   693,   697,   700,   702,
     707,   708,   709,   710,   712,   714,   716,   722,   726,   729,
     731,   736,   736,   736,   737,   737,   737,   738,   738,   738,
     739,   739,   740,   744,   744,   745,   749,   750,   751,   752,
     753,   754,   757,   760,   763,   767,   770,   771,   775,   776,
     777,   778,   779,   780,   781,   782,   783,   784,   785,   786,
     787,   788,   789,   790,   791,   792,   793,   794,   795,   796,
     797,   798,   799,   800,   801,   802,   803,   804,   805,   806,
     807,   808,   809,   810,   811,   812,   813,   814,   815,   816,
     817,   818,   819,   820,   821,   822,   823,   824,   825,   826,
     827,   828,   829,   830
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ADMINISTRATOR", "QSTRING",
  "CHECK_PROXY_TUNNELS", "QUEUE_CHECKS", "AGGRESSIVE", "LOG_ONLY", "ON",
  "OFF", "CHAR_MINUS", "CHAR_I", "CHAR_EXCLAMATION", "IGNORECASE", "COMMA",
  "EQUAL", "PORT", "HTTP_SERVER", "INTERFACE", "IMAGES",
  "HTTPS_PROHIBIT_INSECURE_SSLV2", "HTTPS_CONNECTION_CACHE_SIZE",
  "IDENTIFIER", "WORD", "END", "START_BRACKET", "STOP_BRACKET", "WEEKDAY",
  "CATEGORY", "REWRITE", "ACL", "CPUS", "TIME", "TVAL", "DVAL", "DVALCRON",
  "SOURCE", "CIDR", "IPCLASS", "CONTINUE", "IPADDR", "DBHOME",
  "DOMAINLIST", "EXECDOMAINLIST", "REFRESHDOMAINLIST", "URLLIST",
  "EXPRESSIONLIST", "CACERTS", "CACERTSDIR", "IPLIST", "DOMAIN", "UNIX",
  "LDAP", "USER", "USERLIST", "EXECUSERLIST", "REFRESHUSERLIST",
  "USERQUOTA", "GROUP", "IP", "NL", "NUMBER", "NUMBERS", "PASS",
  "REDIRECT", "SUBST", "CHAR", "MINUTELY", "HOURLY", "DAILY", "WEEKLY",
  "DATE", "REDIRECT_FATAL_ERROR", "REDIRECT_LOADING_DATABASE",
  "REDIRECT_HTTPS", "WITHIN", "OUTSIDE", "ELSE", "ANONYMOUS", "SPORADIC",
  "LOGFILE", "LOGDIR", "LOGPASS", "LOGBLOCK", "LOGALL", "LOGALL_HTTPD",
  "MAIL_SERVER", "ADMIN_EMAIL", "EXTERNAL_STATUS_COMMAND", "TOKEN_ALLOW",
  "TOKEN_DENY", "YOUTUBE_EDUFILTER", "YOUTUBE_EDUFILTER_ID",
  "ALLOW_GOOGLE_HTTPS_USING_IP", "URL_LOOKUP_RESULT_DB_RELOAD",
  "URL_LOOKUP_RESULT_FATAL_ERROR", "URL_LOOKUP_DELAY_DB_RELOAD", "OPTION",
  "UFDB_SHOW_URL_DETAILS", "SQUID_VERSION", "SQUID_USES_SSL_BUMP",
  "STRIP_DOMAIN_FROM_USERNAME", "UFDB_DEBUG_FILTER",
  "UFDB_DEBUG_SKYPE_PROBES", "UFDB_DEBUG_GTALK_PROBES",
  "UFDB_DEBUG_YAHOOMSG_PROBES", "UFDB_DEBUG_AIM_PROBES",
  "UFDB_DEBUG_FBCHAT_PROBES", "UFDB_DEBUG_CITRIXONLINE_PROBES",
  "UFDB_EXPRESSION_OPTIMISATION", "UFDB_EXPRESSION_DEBUG",
  "UFDB_DEBUG_EXTERNAL_SCRIPTS", "UFDB_NUM_WORKER_THREADS",
  "ENFORCE_HTTPS_WITH_HOSTNAME", "ENFORCE_HTTPS_OFFICAL_CERTIFICATE",
  "ALLOW_SKYPE_OVER_HTTPS", "ALLOW_UNKNOWN_PROTOCOL_OVER_HTTPS",
  "ALLOW_GTALK_OVER_HTTPS", "ALLOW_YAHOOMSG_OVER_HTTPS",
  "ALLOW_AIM_OVER_HTTPS", "ALLOW_FBCHAT_OVER_HTTPS",
  "ALLOW_CITRIXONLINE_OVER_HTTPS", "ANALYSE_UNCATEGORISED",
  "LOG_UNCATEGORISED_URLS", "UPLOAD_STATS", "SAFE_SEARCH",
  "MAX_LOGFILE_SIZE", "$accept", "start", "qidentifier",
  "https_cache_size", "allow_or_deny", "on_or_off", "log_pass",
  "log_block", "log_all", "logall_httpd", "youtube_edufilter",
  "youtube_edufilter_id", "allow_google_https_using_ip", "debug_filter",
  "enforce_https_with_hostname", "enforce_https_offical_certificate",
  "https_prohibit_insecure_sslv2", "check_proxy_tunnel_option",
  "check_proxy_tunnels", "admin_spec", "dbhome", "refreshuserlist",
  "refreshdomainlist", "url_lookup_result_db_reload",
  "url_lookup_result_fatal_error", "url_lookup_delay_db_reload",
  "squid_version", "ufdb_show_url_details", "ufdb_debug_skype_probes",
  "ufdb_debug_gtalk_probes", "ufdb_debug_yahoomsg_probes",
  "ufdb_debug_aim_probes", "ufdb_debug_fbchat_probes",
  "ufdb_debug_citrixonline_probes", "ufdb_expression_optimisation",
  "ufdb_expression_debug", "ufdb_debug_external_scripts", "mail_server",
  "admin_email", "external_status_command", "logdir", "port", "interface",
  "cpus", "upload_stats", "redirect_https", "redirect_loading_database",
  "redirect_fatal_error", "log_uncategorised_urls",
  "analyse_uncategorised", "strip_domain_from_username", "safe_search",
  "max_logfile_size", "httpd_option", "httpd_options", "http_server_def",
  "category", "category_block", "category_contents", "category_content",
  "source", "source_block", "source_contents", "source_content", "domain",
  "user", "acl_block", "acl_contents", "acl_header", "acl_content", "$@1",
  "access_contents", "access_content", "access_pass", "cidr", "ipclass",
  "ips", "ip", "rew", "rew_block", "rew_contents", "rew_content", "time",
  "time_block", "time_contents", "time_content", "$@2", "$@3", "$@4",
  "$@5", "$@6", "$@7", "$@8", "ttime", "$@9", "date", "dval", "tval",
  "dvalcron", "an_error", "statements", "statement", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   128,   129,   130,   130,   131,   132,   132,   133,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   141,   142,
     143,   144,   145,   145,   145,   145,   146,   147,   148,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     168,   169,   170,   170,   171,   171,   172,   173,   174,   175,
     176,   177,   177,   178,   179,   180,   181,   181,   181,   181,
     181,   181,   182,   182,   183,   184,   184,   185,   186,   186,
     187,   187,   187,   187,   187,   187,   187,   187,   187,   187,
     187,   187,   187,   187,   187,   187,   187,   187,   187,   187,
     187,   187,   187,   187,   187,   187,   187,   187,   187,   187,
     187,   187,   187,   187,   187,   187,   187,   187,   187,   187,
     187,   187,   188,   189,   190,   190,   191,   191,   191,   191,
     191,   191,   191,   191,   191,   191,   191,   191,   191,   191,
     191,   191,   191,   191,   191,   191,   191,   191,   191,   191,
     191,   191,   192,   192,   192,   192,   193,   193,   193,   193,
     194,   195,   195,   196,   196,   196,   197,   198,   197,   199,
     199,   200,   200,   200,   200,   200,   200,   200,   200,   200,
     201,   201,   201,   201,   201,   201,   202,   203,   204,   204,
     204,   204,   204,   204,   205,   206,   206,   207,   208,   208,
     209,   209,   209,   209,   209,   209,   209,   210,   211,   212,
     212,   214,   215,   213,   216,   217,   213,   218,   219,   213,
     220,   213,   213,   222,   221,   221,   223,   223,   223,   223,
     223,   223,   224,   225,   226,   227,   228,   228,   229,   229,
     229,   229,   229,   229,   229,   229,   229,   229,   229,   229,
     229,   229,   229,   229,   229,   229,   229,   229,   229,   229,
     229,   229,   229,   229,   229,   229,   229,   229,   229,   229,
     229,   229,   229,   229,   229,   229,   229,   229,   229,   229,
     229,   229,   229,   229,   229,   229,   229,   229,   229,   229,
     229,   229,   229,   229
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     1,     2,     1,     1,     1,     1,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     1,     1,     1,     1,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     1,     4,     2,     2,     4,     0,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       3,     3,     3,     3,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     3,     3,     2,     3,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     2,     2,     4,     0,     2,     2,     2,     3,     2,
       2,     3,     3,     2,     2,     2,     3,     3,     4,     4,
       4,     4,     2,     2,     2,     2,     2,     3,     3,     2,
       2,     1,     0,     2,     2,     2,     0,     2,     2,     2,
       4,     0,     2,     2,     4,     4,     3,     0,     8,     0,
       2,     2,     2,     2,     2,     2,     3,     3,     2,     2,
       0,     2,     2,     3,     3,     2,     1,     1,     0,     2,
       3,     3,     4,     2,     1,     2,     2,     4,     0,     2,
       1,     2,     2,     3,     3,     2,     2,     2,     4,     0,
       2,     0,     0,     5,     0,     0,     5,     0,     0,     5,
       0,     3,     1,     0,     5,     3,     2,     1,     4,     3,
       2,     1,     1,     1,     1,     1,     0,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
     236,     0,     0,     1,   235,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   292,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   243,
     245,   246,   247,   248,   285,   287,   286,   249,   250,   251,
     252,   244,   242,   253,   271,   272,   259,   260,   258,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   273,
     255,   256,   257,   254,   275,   274,   276,   277,   278,   279,
     280,   282,   281,   284,   283,   288,   241,   238,   240,     0,
     239,   289,     0,   290,     0,   291,   293,   237,    27,    23,
      24,    25,    22,    26,    51,     0,     4,     3,    53,    52,
       8,     9,    21,     5,    76,    75,   196,   195,   161,    54,
      55,   207,   122,    29,    28,    31,    30,    59,    58,    57,
      50,    49,    10,    11,    12,    13,    46,    47,    48,    14,
      15,    16,     6,     7,    32,    33,    34,    36,    35,    63,
      18,    17,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    19,    20,    62,    61,    60,    56,    64,    65,    78,
     124,   198,   209,     0,     0,     0,    73,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    74,   160,     0,
     169,   162,    77,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    79,   123,   151,     0,   152,
       0,   156,     0,     0,     0,     0,   188,     0,     0,     0,
     125,   197,   200,     0,     0,     0,   199,   222,   208,   214,
     220,   210,    66,    68,    69,    67,    71,    70,    72,   163,
       0,     0,     0,   101,   100,    82,    81,    80,    83,    86,
      85,    84,    89,     0,     0,    88,    87,    95,    94,    97,
      96,    99,    98,   102,   103,   121,     0,   120,     0,     0,
     106,   108,     0,     0,     0,     0,     0,     0,     0,     0,
     144,   143,   126,   156,     0,     0,   127,   130,   129,   133,
       0,   135,   134,   142,   145,   146,   150,     0,   149,   201,
     202,   206,     0,   205,     0,     0,     0,     0,     0,     0,
     166,     0,   180,     0,     0,   170,    91,    90,    93,    92,
     119,   118,   110,   105,   107,   109,   111,   117,   112,   113,
     114,   115,   116,   104,   155,   154,   153,   128,   132,   131,
     137,   136,   159,   158,   157,     0,   193,   194,   189,   148,
     147,   204,   203,   212,   215,   218,   232,   234,   221,   227,
     231,   164,   165,   167,   173,   172,   171,   175,   174,   179,
       0,   178,   141,   138,   139,   140,     0,   186,   187,   190,
     191,     0,     0,     0,     0,   233,   226,     0,   230,     0,
     181,     0,   185,   182,   177,   176,   192,   213,   216,   219,
     229,     0,     0,   169,   183,   184,   228,     0,   225,     0,
       0,   168,   224
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,   364,    59,   164,   132,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,   123,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   196,   197,   106,   107,   108,   199,   225,
     109,   110,   200,   240,   302,   306,   111,   198,   210,   211,
     409,   262,   335,   386,   399,   400,   313,   368,   112,   113,
     201,   246,   114,   115,   202,   251,   324,   401,   325,   402,
     326,   403,   327,   406,   421,   378,   379,   407,   380,   116,
       2,   117
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -305
static const yytype_int16 yypact[] =
{
    -305,    10,    50,  -305,  -305,    -2,   421,   -47,     6,   214,
      13,   -45,   180,    66,    33,   128,    71,    71,   246,    -1,
      26,  -305,    87,    93,   105,   249,    13,    13,    13,    13,
     116,   125,   137,    13,   163,    13,   103,   103,    13,    13,
     166,    13,     2,    13,    13,    13,    13,    13,    13,    13,
      13,    13,    13,    13,     4,    13,    13,    13,    52,  -305,
    -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,
    -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,
    -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,
    -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,
    -305,  -305,  -305,  -305,  -305,  -305,  -305,   156,  -305,   190,
    -305,  -305,   199,  -305,   201,  -305,  -305,  -305,  -305,  -305,
    -305,  -305,  -305,  -305,  -305,   102,  -305,  -305,  -305,  -305,
    -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,
    -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,
    -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,
    -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,
    -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,
    -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,
    -305,  -305,  -305,   217,   225,   227,   229,   239,   165,   271,
     283,    -3,    59,   192,   174,   303,   102,  -305,  -305,   -20,
    -305,  -305,  -305,   305,   236,    71,   238,   234,   326,   342,
     347,    71,    71,    61,   -16,  -305,  -305,  -305,   349,  -305,
     245,  -305,   351,    71,   206,   359,  -305,    71,    71,    89,
    -305,  -305,  -305,    71,    71,    92,  -305,  -305,  -305,    34,
    -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,
      71,    71,   121,  -305,  -305,  -305,  -305,  -305,  -305,  -305,
    -305,  -305,  -305,   363,   372,  -305,  -305,  -305,  -305,  -305,
    -305,  -305,  -305,  -305,  -305,  -305,   374,  -305,    13,    13,
      13,    13,    13,    13,    13,    13,    13,    13,    13,    13,
    -305,  -305,   252,  -305,   376,   380,   288,  -305,  -305,  -305,
     209,  -305,  -305,    11,  -305,  -305,  -305,   384,  -305,  -305,
    -305,  -305,   386,  -305,   235,    71,   250,   196,   253,   268,
     200,   388,  -305,   390,   104,  -305,  -305,  -305,  -305,  -305,
    -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,
    -305,  -305,  -305,  -305,  -305,  -305,  -305,   288,  -305,  -305,
    -305,  -305,  -305,  -305,  -305,   110,  -305,  -305,   -10,  -305,
    -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,    43,
     263,  -305,  -305,  -305,  -305,  -305,   411,  -305,  -305,  -305,
     397,  -305,  -305,  -305,  -305,  -305,   265,  -305,  -305,  -305,
    -305,   263,   263,   263,   296,  -305,   306,   321,   306,   318,
    -305,   298,  -305,  -305,  -305,  -305,  -305,   306,   306,   306,
     263,   263,   263,  -305,  -305,  -305,   306,   334,  -305,   136,
     263,  -305,  -305
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -305,  -305,    -9,  -305,   317,    -8,  -305,  -305,  -305,  -305,
    -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,
    -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,
    -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,
    -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,
    -305,  -305,  -305,  -305,   150,  -305,  -305,  -305,  -305,  -305,
    -305,  -305,  -305,  -305,  -305,    54,  -305,  -305,  -305,  -305,
    -305,   -65,  -305,  -305,  -305,  -305,  -305,   -35,  -305,  -305,
    -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,  -305,
    -305,  -305,  -305,  -181,  -305,  -305,   -42,  -304,  -305,  -305,
    -305,  -305
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -224
static const yytype_int16 yytable[] =
{
     129,   396,   118,   135,   137,   288,   259,   141,   142,   144,
       3,   130,   131,   130,   131,   124,   151,   133,   152,   153,
     154,   155,   130,   131,   241,   159,   366,   161,   397,   398,
     166,   167,   125,   169,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   184,   185,   186,   187,
      -2,     4,   367,     5,   404,     6,   260,   261,  -217,   138,
     247,   145,  -211,   242,   170,   126,   183,     7,     8,     9,
     126,    10,    11,   243,   244,   126,   289,   405,   245,    12,
      13,    14,    15,    16,   127,   285,   248,    17,   146,   127,
     136,   147,    18,   126,   127,    19,   126,   148,   290,   291,
     292,   293,   294,   295,   296,   297,   298,    20,   126,   149,
     299,    21,   127,   316,   188,   127,   321,   427,   428,   193,
     156,   194,   195,    22,    23,    24,   432,   127,   389,   157,
     249,   250,    25,    26,    27,    28,    29,    30,    31,    32,
     286,   158,    33,    34,    35,    36,    37,    38,   330,    39,
      40,   331,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,   431,    52,    53,   331,   160,   317,   126,
     168,   322,   392,    54,    55,    56,    57,    58,   126,   393,
     394,   395,   189,   390,   126,   332,   333,   134,   127,   209,
     139,   140,   208,   162,   163,   255,   257,   127,   253,   408,
     332,   333,   334,   127,   264,   267,   268,   271,   276,   278,
     280,   282,   283,   284,   287,   254,   190,   334,   126,   301,
     417,   418,   419,   308,   309,   191,   312,   192,   314,   315,
     318,   376,   377,   203,   319,   320,   323,   127,   126,   426,
     126,   204,   126,   205,   206,   272,   273,   265,   274,   269,
     126,   328,   329,   126,   252,   128,   126,   127,   275,   127,
     266,   127,   270,   373,   337,   339,   207,   354,   310,   127,
     143,   365,   127,   150,   375,   127,   355,   341,   383,   381,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   126,   356,   382,   359,   361,   405,   212,   303,
     304,   213,   126,   362,   305,   424,   367,   126,   370,   126,
     226,   127,   363,   372,   214,   215,   374,   216,   217,   218,
     219,   127,   385,   227,   388,   391,   127,   256,   127,   263,
     126,   376,   422,   228,   229,   230,   220,   231,   232,   233,
    -223,   234,   235,   236,   423,   430,   126,   221,   222,   127,
     277,   126,   223,   126,   165,   126,   258,   357,   429,   237,
     238,   416,   420,   126,   239,   127,   279,   126,     0,   224,
     127,   281,   127,   300,   127,   307,   126,   413,   126,     0,
     126,   415,   127,   311,   126,     0,   127,   336,   126,     0,
     126,     0,   126,     0,   126,   127,   338,   127,   340,   127,
     358,   126,   425,   127,   360,     0,     0,   127,   369,   127,
     371,   127,   384,   127,   387,   126,     0,     0,   410,     0,
     127,   414,     0,     0,   411,     0,   412,   119,   120,   121,
       0,   122,     0,     0,   127
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-305)))

#define yytable_value_is_error(Yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
       9,    11,     4,    12,    13,    21,    26,    16,    17,    18,
       0,     9,    10,     9,    10,    62,    25,    62,    26,    27,
      28,    29,     9,    10,    27,    33,    15,    35,    38,    39,
      38,    39,    26,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
       0,     1,    41,     3,    11,     5,    76,    77,    24,    26,
       1,    62,    28,    66,    62,     4,    62,    17,    18,    19,
       4,    21,    22,    76,    77,     4,    92,    34,    81,    29,
      30,    31,    32,    33,    23,    24,    27,    37,    62,    23,
      24,     4,    42,     4,    23,    45,     4,     4,   114,   115,
     116,   117,   118,   119,   120,   121,   122,    57,     4,     4,
     126,    61,    23,    24,    62,    23,    24,   421,   422,    17,
       4,    19,    20,    73,    74,    75,   430,    23,    24,     4,
      71,    72,    82,    83,    84,    85,    86,    87,    88,    89,
      79,     4,    92,    93,    94,    95,    96,    97,    27,    99,
     100,    30,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,    27,   114,   115,    30,     4,    79,     4,
       4,    79,    62,   123,   124,   125,   126,   127,     4,    69,
      70,    71,    26,    79,     4,    64,    65,     7,    23,   198,
      62,    63,    27,    90,    91,   204,   205,    23,    24,   380,
      64,    65,    81,    23,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,    41,    26,    81,     4,   228,
     401,   402,   403,   232,   233,    26,   235,    26,   237,   238,
     239,    35,    36,    16,   243,   244,   245,    23,     4,   420,
       4,    16,     4,    16,    15,    11,    12,    11,    14,    11,
       4,   260,   261,     4,    62,    41,     4,    23,    24,    23,
      24,    23,    24,    28,   273,   274,    27,    15,    62,    23,
      24,    62,    23,    24,    24,    23,    24,   286,    78,    26,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,     4,   302,    26,   304,   305,    34,    27,    54,
      55,    30,     4,    15,    59,     7,    41,     4,   317,     4,
      27,    23,    24,   322,    43,    44,   325,    46,    47,    48,
      49,    23,   331,    40,   333,   334,    23,    24,    23,    24,
       4,    35,    11,    50,    51,    52,    65,    54,    55,    56,
      34,    58,    59,    60,    26,    11,     4,    76,    77,    23,
      24,     4,    81,     4,    37,     4,   206,   303,   423,    76,
      77,   396,   404,     4,    81,    23,    24,     4,    -1,    98,
      23,    24,    23,    24,    23,    24,     4,   386,     4,    -1,
       4,   390,    23,    24,     4,    -1,    23,    24,     4,    -1,
       4,    -1,     4,    -1,     4,    23,    24,    23,    24,    23,
      24,     4,   411,    23,    24,    -1,    -1,    23,    24,    23,
      24,    23,    24,    23,    24,     4,    -1,    -1,     7,    -1,
      23,    24,    -1,    -1,    13,    -1,    15,     6,     7,     8,
      -1,    10,    -1,    -1,    23
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,   129,   228,     0,     1,     3,     5,    17,    18,    19,
      21,    22,    29,    30,    31,    32,    33,    37,    42,    45,
      57,    61,    73,    74,    75,    82,    83,    84,    85,    86,
      87,    88,    89,    92,    93,    94,    95,    96,    97,    99,
     100,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   114,   115,   123,   124,   125,   126,   127,   131,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   183,   184,   185,   188,
     189,   194,   206,   207,   210,   211,   227,   229,     4,     6,
       7,     8,    10,   145,    62,    26,     4,    23,    41,   130,
       9,    10,   133,    62,     7,   130,    24,   130,    26,    62,
      63,   130,   130,    24,   130,    62,    62,     4,     4,     4,
      24,   130,   133,   133,   133,   133,     4,     4,     4,   133,
       4,   133,    90,    91,   132,   132,   133,   133,     4,   133,
      62,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,    62,   133,   133,   133,   133,    62,    26,
      26,    26,    26,    17,    19,    20,   181,   182,   195,   186,
     190,   208,   212,    16,    16,    16,    15,    27,    27,   130,
     196,   197,    27,    30,    43,    44,    46,    47,    48,    49,
      65,    76,    77,    81,    98,   187,    27,    40,    50,    51,
      52,    54,    55,    56,    58,    59,    60,    76,    77,    81,
     191,    27,    66,    76,    77,    81,   209,     1,    27,    71,
      72,   213,    62,    24,    41,   130,    24,   130,   182,    26,
      76,    77,   199,    24,   130,    11,    24,   130,   130,    11,
      24,   130,    11,    12,    14,    24,   130,    24,   130,    24,
     130,    24,   130,   130,   130,    24,    79,   130,    21,    92,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   126,
      24,   130,   192,    54,    55,    59,   193,    24,   130,   130,
      62,    24,   130,   204,   130,   130,    24,    79,   130,   130,
     130,    24,    79,   130,   214,   216,   218,   220,   130,   130,
      27,    30,    64,    65,    81,   200,    24,   130,    24,   130,
      24,   130,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,    15,    24,   130,   193,    24,   130,
      24,   130,    15,    24,   130,    62,    15,    41,   205,    24,
     130,    24,   130,    28,   130,    24,    35,    36,   223,   224,
     226,    26,    26,    78,    24,   130,   201,    24,   130,    24,
      79,   130,    62,    69,    70,    71,    11,    38,    39,   202,
     203,   215,   217,   219,    11,    34,   221,   225,   221,   198,
       7,    13,    15,   130,    24,   130,   205,   221,   221,   221,
     224,   222,    11,    26,     7,   130,   221,   225,   225,   199,
      11,    27,   225
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
/* Line 1792 of yacc.c  */
#line 197 "sg.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); }
    break;

  case 4:
/* Line 1792 of yacc.c  */
#line 198 "sg.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); }
    break;

  case 5:
/* Line 1792 of yacc.c  */
#line 202 "sg.y"
    { httpsConnectionCacheSize = atoi( (yyvsp[(2) - (2)].string) ); ufdbFree( (yyvsp[(2) - (2)].string) ); }
    break;

  case 6:
/* Line 1792 of yacc.c  */
#line 206 "sg.y"
    { (yyval.integer) = UFDB_ALLOW; }
    break;

  case 7:
/* Line 1792 of yacc.c  */
#line 207 "sg.y"
    { (yyval.integer) = UFDB_DENY; }
    break;

  case 8:
/* Line 1792 of yacc.c  */
#line 211 "sg.y"
    { (yyval.integer) = 1; }
    break;

  case 9:
/* Line 1792 of yacc.c  */
#line 212 "sg.y"
    { (yyval.integer) = 0; }
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 216 "sg.y"
    { UFDBglobalLogPass = (yyvsp[(2) - (2)].integer); }
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 220 "sg.y"
    { UFDBglobalLogBlock = (yyvsp[(2) - (2)].integer); }
    break;

  case 12:
/* Line 1792 of yacc.c  */
#line 224 "sg.y"
    { UFDBglobalLogAllRequests = (yyvsp[(2) - (2)].integer); }
    break;

  case 13:
/* Line 1792 of yacc.c  */
#line 228 "sg.y"
    { UFDBglobalDebugHttpd = (yyvsp[(2) - (2)].integer); }
    break;

  case 14:
/* Line 1792 of yacc.c  */
#line 232 "sg.y"
    { UFDBglobalYoutubeEdufilter = (yyvsp[(2) - (2)].integer); }
    break;

  case 15:
/* Line 1792 of yacc.c  */
#line 236 "sg.y"
    { UFDBglobalYoutubeEdufilterID = (yyvsp[(2) - (2)].string); }
    break;

  case 16:
/* Line 1792 of yacc.c  */
#line 240 "sg.y"
    { UFDBglobalAllowGoogleHTTPSusingIP = (yyvsp[(2) - (2)].integer); }
    break;

  case 17:
/* Line 1792 of yacc.c  */
#line 244 "sg.y"
    { UFDBglobalDebug = (yyvsp[(2) - (2)].integer); }
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 245 "sg.y"
    { UFDBglobalDebug = atoi( (yyvsp[(2) - (2)].string) ); }
    break;

  case 19:
/* Line 1792 of yacc.c  */
#line 250 "sg.y"
    { ufdbLogError( "line %d: option enforce-https-with-hostname must be part of the security category", lineno );  }
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 255 "sg.y"
    { ufdbLogError( "line %d: option enforce-https-official-certificate must be part of the security category", lineno );  }
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 260 "sg.y"
    { ufdbLogError( "line %d: option https-prohibit-insecure-sslv2 must be part of the security category", lineno );  }
    break;

  case 22:
/* Line 1792 of yacc.c  */
#line 265 "sg.y"
    { (yyval.integer) = UFDB_API_HTTPS_CHECK_OFF; }
    break;

  case 23:
/* Line 1792 of yacc.c  */
#line 266 "sg.y"
    { (yyval.integer) = UFDB_API_HTTPS_CHECK_QUEUE_CHECKS; }
    break;

  case 24:
/* Line 1792 of yacc.c  */
#line 267 "sg.y"
    { (yyval.integer) = UFDB_API_HTTPS_CHECK_AGGRESSIVE; }
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 268 "sg.y"
    { (yyval.integer) = UFDB_API_HTTPS_LOG_ONLY; }
    break;

  case 26:
/* Line 1792 of yacc.c  */
#line 272 "sg.y"
    { UFDBsetTunnelCheckMethod( (yyvsp[(2) - (2)].integer) ); }
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 276 "sg.y"
    { ufdbSetting("administrator",(yyvsp[(2) - (2)].string)); }
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 280 "sg.y"
    { ufdbSetting("dbhome",(yyvsp[(2) - (2)].string)); }
    break;

  case 29:
/* Line 1792 of yacc.c  */
#line 281 "sg.y"
    { ufdbSetting("dbhome",(yyvsp[(2) - (2)].string)); }
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 285 "sg.y"
    { setRefreshUserlist( atoi((yyvsp[(2) - (2)].string)) ); }
    break;

  case 31:
/* Line 1792 of yacc.c  */
#line 289 "sg.y"
    { setRefreshDomainlist( atoi((yyvsp[(2) - (2)].string)) ); }
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 294 "sg.y"
    { UFDBglobalURLlookupResultDBreload = (yyvsp[(2) - (2)].integer); }
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 298 "sg.y"
    { UFDBglobalURLlookupResultFatalError = (yyvsp[(2) - (2)].integer); }
    break;

  case 34:
/* Line 1792 of yacc.c  */
#line 302 "sg.y"
    { UFDBglobalURLlookupDelayDBreload = (yyvsp[(2) - (2)].integer); }
    break;

  case 35:
/* Line 1792 of yacc.c  */
#line 306 "sg.y"
    { ufdbFree( UFDBglobalSquidVersion );  UFDBglobalSquidVersion = (yyvsp[(2) - (2)].string);  }
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 310 "sg.y"
    { UFDBglobalShowURLdetails = (yyvsp[(2) - (2)].integer); }
    break;

  case 37:
/* Line 1792 of yacc.c  */
#line 314 "sg.y"
    { UFDBglobalDebugSkype = (yyvsp[(2) - (2)].integer); }
    break;

  case 38:
/* Line 1792 of yacc.c  */
#line 318 "sg.y"
    { UFDBglobalDebugGtalk = (yyvsp[(2) - (2)].integer); }
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 322 "sg.y"
    { UFDBglobalDebugYahooMsg = (yyvsp[(2) - (2)].integer); }
    break;

  case 40:
/* Line 1792 of yacc.c  */
#line 326 "sg.y"
    { UFDBglobalDebugAim = (yyvsp[(2) - (2)].integer); }
    break;

  case 41:
/* Line 1792 of yacc.c  */
#line 330 "sg.y"
    { UFDBglobalDebugFBchat = (yyvsp[(2) - (2)].integer); }
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 334 "sg.y"
    { UFDBglobalDebugCitrixOnline = (yyvsp[(2) - (2)].integer); }
    break;

  case 43:
/* Line 1792 of yacc.c  */
#line 338 "sg.y"
    { UFDBglobalExpressionOptimisation = (yyvsp[(2) - (2)].integer); }
    break;

  case 44:
/* Line 1792 of yacc.c  */
#line 342 "sg.y"
    { UFDBglobalDebugRegexp = (yyvsp[(2) - (2)].integer); }
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 346 "sg.y"
    { UFDBglobalDebugExternalScripts = (yyvsp[(2) - (2)].integer); }
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 350 "sg.y"
    { ufdbFree( UFDBglobalEmailServer ); UFDBglobalEmailServer = (yyvsp[(2) - (2)].string); }
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 354 "sg.y"
    { ufdbFree( UFDBglobalAdminEmail ); UFDBglobalAdminEmail = (yyvsp[(2) - (2)].string); }
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 358 "sg.y"
    {  ufdbFree( UFDBglobalExternalStatusCommand );  UFDBglobalExternalStatusCommand = (yyvsp[(2) - (2)].string); }
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 362 "sg.y"
    { ufdbSetting("logdir",(yyvsp[(2) - (2)].string)); }
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 363 "sg.y"
    { ufdbSetting("logdir",(yyvsp[(2) - (2)].string)); }
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 367 "sg.y"
    { ufdbSetting( "port", (yyvsp[(2) - (2)].string) ); }
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 371 "sg.y"
    { 
#if HAVE_UNIX_SOCKETS
                                             ufdbLogError( "ufdbguardd is configured to use UNIX sockets.  \"interface\" is ignored." );
#else
		                             if (strcmp((yyvsp[(2) - (2)].string),"all")== 0)
						strcpy( UFDBglobalInterface, "all" );    
					     else
					        ufdbLogFatalError( "interface must be \"all\" or IP address" );
#endif
					     ufdbFree( (yyvsp[(2) - (2)].string) );
					   }
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 382 "sg.y"
    { strcpy( UFDBglobalInterface, (yyvsp[(2) - (2)].string) );  ufdbFree( (yyvsp[(2) - (2)].string) ); }
    break;

  case 54:
/* Line 1792 of yacc.c  */
#line 386 "sg.y"
    { ufdbSetCPU( (yyvsp[(2) - (2)].string) ); ufdbFree( (yyvsp[(2) - (2)].string) ); }
    break;

  case 55:
/* Line 1792 of yacc.c  */
#line 387 "sg.y"
    { ufdbSetCPU( (yyvsp[(2) - (2)].string) ); ufdbFree( (yyvsp[(2) - (2)].string) ); }
    break;

  case 56:
/* Line 1792 of yacc.c  */
#line 392 "sg.y"
    { UFDBglobalUploadStats = (yyvsp[(2) - (2)].integer);   }
    break;

  case 57:
/* Line 1792 of yacc.c  */
#line 397 "sg.y"
    { strcpy( UFDBglobalRedirectHttps, (yyvsp[(2) - (2)].string) );  ufdbFree( (yyvsp[(2) - (2)].string) );  }
    break;

  case 58:
/* Line 1792 of yacc.c  */
#line 402 "sg.y"
    { strcpy( UFDBglobalLoadingDatabaseRedirect, (yyvsp[(2) - (2)].string) );  ufdbFree( (yyvsp[(2) - (2)].string) );  }
    break;

  case 59:
/* Line 1792 of yacc.c  */
#line 407 "sg.y"
    { strcpy( UFDBglobalFatalErrorRedirect, (yyvsp[(2) - (2)].string) );  ufdbFree( (yyvsp[(2) - (2)].string) );  }
    break;

  case 60:
/* Line 1792 of yacc.c  */
#line 412 "sg.y"
    {
			UFDBglobalLogUncategorisedURLs = (yyvsp[(2) - (2)].integer);   
		     }
    break;

  case 61:
/* Line 1792 of yacc.c  */
#line 419 "sg.y"
    { 
		        if (UFDBglobalAnalyseUncategorisedURLs < 0)
			   ufdbLogMessage( "option analyse-uncategorised-urls is overruled by -N option *****" );
		        else
		           UFDBglobalAnalyseUncategorisedURLs = (yyvsp[(2) - (2)].integer);   
		     }
    break;

  case 62:
/* Line 1792 of yacc.c  */
#line 427 "sg.y"
    {
		        if (UFDBglobalAnalyseUncategorisedURLs < 0)
			   ufdbLogMessage( "option analyse-uncategorised-urls is overruled by -N option *****" );
		        else
			{
		           UFDBglobalAnalyseUncategorisedURLs = atoi( (yyvsp[(2) - (2)].string) ); 
			   ufdbFree( (yyvsp[(2) - (2)].string) ); 
			}
		     }
    break;

  case 63:
/* Line 1792 of yacc.c  */
#line 440 "sg.y"
    {
		        UFDBglobalStripDomainFromUsername = (yyvsp[(2) - (2)].integer);
		     }
    break;

  case 64:
/* Line 1792 of yacc.c  */
#line 447 "sg.y"
    { UFDBglobalSafeSearch = (yyvsp[(2) - (2)].integer); }
    break;

  case 65:
/* Line 1792 of yacc.c  */
#line 452 "sg.y"
    { 
		       UFDBglobalMaxLogfileSize = strtoul( (yyvsp[(2) - (2)].string), NULL, 10 );
		       ufdbFree( (yyvsp[(2) - (2)].string) );
		       if (UFDBglobalMaxLogfileSize < 2 * 1024 * 1024)		/* minimum is 2 MB */
		          UFDBglobalMaxLogfileSize = 2 * 1024 * 1024;
		       if (UFDBglobalMaxLogfileSize > 2000000000)		/* maximum is 2 GB */
		          UFDBglobalMaxLogfileSize = 2000000000;
		     }
    break;

  case 66:
/* Line 1792 of yacc.c  */
#line 463 "sg.y"
    { UFDBglobalHttpdPort = atoi( (yyvsp[(3) - (3)].string) ); ufdbFree( (yyvsp[(3) - (3)].string) ); }
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 464 "sg.y"
    { if (strcmp((yyvsp[(3) - (3)].string),"all")== 0)
						strcpy( UFDBglobalHttpdInterface, "all" );    
					     else
					        ufdbLogFatalError( "http-server interface must be \"all\" or IP address" );
					     ufdbFree( (yyvsp[(3) - (3)].string) );
					   }
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 470 "sg.y"
    { if (strcmp((yyvsp[(3) - (3)].string),"all")== 0)
						strcpy( UFDBglobalHttpdInterface, "all" );    
					     else
					        ufdbLogFatalError( "http-server interface must be \"all\" or IP address" );
					     ufdbFree( (yyvsp[(3) - (3)].string) );
					   }
    break;

  case 69:
/* Line 1792 of yacc.c  */
#line 476 "sg.y"
    { strcpy( UFDBglobalHttpdInterface, (yyvsp[(3) - (3)].string) );       ufdbFree( (yyvsp[(3) - (3)].string) ); }
    break;

  case 70:
/* Line 1792 of yacc.c  */
#line 477 "sg.y"
    { strcpy( UFDBglobalHttpdImagesDirectory, (yyvsp[(3) - (3)].string) ); ufdbFree( (yyvsp[(3) - (3)].string) ); }
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 478 "sg.y"
    { strcpy( UFDBglobalHttpdImagesDirectory, (yyvsp[(3) - (3)].string) ); ufdbFree( (yyvsp[(3) - (3)].string) ); }
    break;

  case 75:
/* Line 1792 of yacc.c  */
#line 491 "sg.y"
    { ufdbCategory((yyvsp[(2) - (2)].string)); }
    break;

  case 76:
/* Line 1792 of yacc.c  */
#line 492 "sg.y"
    { ufdbCategory( ufdbStrdup("aggressive") );
		                         yyerror( "\"aggressive\" is a keyword and must be surrounded by quotes" ); }
    break;

  case 77:
/* Line 1792 of yacc.c  */
#line 498 "sg.y"
    { ufdbCategoryEnd(); }
    break;

  case 80:
/* Line 1792 of yacc.c  */
#line 506 "sg.y"
    { ufdbCategoryDomainList( (yyvsp[(2) - (2)].string) ); }
    break;

  case 81:
/* Line 1792 of yacc.c  */
#line 507 "sg.y"
    { ufdbCategoryDomainList( (yyvsp[(2) - (2)].string) ); }
    break;

  case 82:
/* Line 1792 of yacc.c  */
#line 508 "sg.y"
    { ufdbCategoryDomainList( NULL ); }
    break;

  case 83:
/* Line 1792 of yacc.c  */
#line 509 "sg.y"
    { ufdbCategoryExecDomainList( (yyvsp[(2) - (2)].string) ); }
    break;

  case 84:
/* Line 1792 of yacc.c  */
#line 510 "sg.y"
    { ufdbCategoryUrlList( (yyvsp[(2) - (2)].string) ); }
    break;

  case 85:
/* Line 1792 of yacc.c  */
#line 511 "sg.y"
    { ufdbCategoryUrlList( (yyvsp[(2) - (2)].string) ); }
    break;

  case 86:
/* Line 1792 of yacc.c  */
#line 512 "sg.y"
    { ufdbCategoryUrlList( NULL ); }
    break;

  case 87:
/* Line 1792 of yacc.c  */
#line 513 "sg.y"
    { ufdbCategoryExpressionList( (yyvsp[(2) - (2)].string), "n" ); }
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 514 "sg.y"
    { ufdbCategoryExpressionList( (yyvsp[(2) - (2)].string), "n" ); }
    break;

  case 89:
/* Line 1792 of yacc.c  */
#line 515 "sg.y"
    { ufdbCategoryExpressionList( NULL, NULL ); }
    break;

  case 90:
/* Line 1792 of yacc.c  */
#line 516 "sg.y"
    { ufdbCategoryExpressionList( (yyvsp[(3) - (3)].string), "i" ); }
    break;

  case 91:
/* Line 1792 of yacc.c  */
#line 517 "sg.y"
    { ufdbCategoryExpressionList( (yyvsp[(3) - (3)].string), "i" ); }
    break;

  case 92:
/* Line 1792 of yacc.c  */
#line 518 "sg.y"
    { ufdbCategoryExpressionList( (yyvsp[(3) - (3)].string), "i" ); }
    break;

  case 93:
/* Line 1792 of yacc.c  */
#line 519 "sg.y"
    { ufdbCategoryExpressionList( (yyvsp[(3) - (3)].string), "i" ); }
    break;

  case 94:
/* Line 1792 of yacc.c  */
#line 520 "sg.y"
    { ufdbCategoryCACertsFile( (yyvsp[(2) - (2)].string) ); }
    break;

  case 95:
/* Line 1792 of yacc.c  */
#line 521 "sg.y"
    { ufdbCategoryCACertsFile( (yyvsp[(2) - (2)].string) ); }
    break;

  case 96:
/* Line 1792 of yacc.c  */
#line 522 "sg.y"
    { ufdbCategoryCACertsDir( (yyvsp[(2) - (2)].string) ); }
    break;

  case 97:
/* Line 1792 of yacc.c  */
#line 523 "sg.y"
    { ufdbCategoryCACertsDir( (yyvsp[(2) - (2)].string) ); }
    break;

  case 98:
/* Line 1792 of yacc.c  */
#line 524 "sg.y"
    { ufdbCategoryRedirect( (yyvsp[(2) - (2)].string) ); }
    break;

  case 99:
/* Line 1792 of yacc.c  */
#line 525 "sg.y"
    { ufdbCategoryRedirect( (yyvsp[(2) - (2)].string) ); }
    break;

  case 100:
/* Line 1792 of yacc.c  */
#line 526 "sg.y"
    { ufdbCategoryRewrite( (yyvsp[(2) - (2)].string) ); }
    break;

  case 101:
/* Line 1792 of yacc.c  */
#line 527 "sg.y"
    { ufdbCategoryRewrite( (yyvsp[(2) - (2)].string) ); }
    break;

  case 102:
/* Line 1792 of yacc.c  */
#line 528 "sg.y"
    { ufdbCategoryTime( (yyvsp[(2) - (2)].string), UFDB_ACL_WITHIN ); }
    break;

  case 103:
/* Line 1792 of yacc.c  */
#line 529 "sg.y"
    { ufdbCategoryTime( (yyvsp[(2) - (2)].string), UFDB_ACL_OUTSIDE ); }
    break;

  case 104:
/* Line 1792 of yacc.c  */
#line 530 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_SAFE_SEARCH );  }
    break;

  case 105:
/* Line 1792 of yacc.c  */
#line 531 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_YOUTUBE_EDUFILTER );  }
    break;

  case 106:
/* Line 1792 of yacc.c  */
#line 532 "sg.y"
    { ufdbCategoryOption(  1, UFDB_OPT_HTTPS_WITH_HOSTNAME );  }
    break;

  case 107:
/* Line 1792 of yacc.c  */
#line 533 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_HTTPS_WITH_HOSTNAME );  }
    break;

  case 108:
/* Line 1792 of yacc.c  */
#line 534 "sg.y"
    { ufdbCategoryOption(  1, UFDB_OPT_HTTPS_OFFICAL_CERTIFICATE );  }
    break;

  case 109:
/* Line 1792 of yacc.c  */
#line 535 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_HTTPS_OFFICAL_CERTIFICATE );  }
    break;

  case 110:
/* Line 1792 of yacc.c  */
#line 536 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_PROHIBIT_INSECURE_SSLV2 );  }
    break;

  case 111:
/* Line 1792 of yacc.c  */
#line 537 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_SKYPE_OVER_HTTPS );  }
    break;

  case 112:
/* Line 1792 of yacc.c  */
#line 538 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_GTALK_OVER_HTTPS );  }
    break;

  case 113:
/* Line 1792 of yacc.c  */
#line 539 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_YAHOOMSG_OVER_HTTPS );  }
    break;

  case 114:
/* Line 1792 of yacc.c  */
#line 540 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_AIM_OVER_HTTPS );  }
    break;

  case 115:
/* Line 1792 of yacc.c  */
#line 541 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_FBCHAT_OVER_HTTPS );  }
    break;

  case 116:
/* Line 1792 of yacc.c  */
#line 542 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_CITRIXONLINE_OVER_HTTPS );  }
    break;

  case 117:
/* Line 1792 of yacc.c  */
#line 543 "sg.y"
    { ufdbCategoryOption( (yyvsp[(3) - (3)].integer), UFDB_OPT_UNKNOWN_PROTOCOL_OVER_HTTPS );  }
    break;

  case 118:
/* Line 1792 of yacc.c  */
#line 544 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(3) - (3)].string) ); 
		                                  ufdbFree( (yyvsp[(3) - (3)].string) ); }
    break;

  case 119:
/* Line 1792 of yacc.c  */
#line 546 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(3) - (3)].string) ); 
		                                  ufdbFree( (yyvsp[(3) - (3)].string) ); }
    break;

  case 120:
/* Line 1792 of yacc.c  */
#line 548 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(2) - (2)].string) ); 
		                                  ufdbFree( (yyvsp[(2) - (2)].string) ); }
    break;

  case 121:
/* Line 1792 of yacc.c  */
#line 550 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(2) - (2)].string) ); 
		                                  ufdbFree( (yyvsp[(2) - (2)].string) ); }
    break;

  case 122:
/* Line 1792 of yacc.c  */
#line 555 "sg.y"
    { defSource( (yyvsp[(2) - (2)].string) ); }
    break;

  case 123:
/* Line 1792 of yacc.c  */
#line 559 "sg.y"
    { defSourceEnd(); }
    break;

  case 129:
/* Line 1792 of yacc.c  */
#line 571 "sg.y"
    { ufdbSourceUserList( (yyvsp[(2) - (2)].string) ); }
    break;

  case 130:
/* Line 1792 of yacc.c  */
#line 572 "sg.y"
    { ufdbSourceUserList( (yyvsp[(2) - (2)].string) ); }
    break;

  case 131:
/* Line 1792 of yacc.c  */
#line 573 "sg.y"
    { ufdbSourceUserList( (yyvsp[(3) - (3)].string) ); }
    break;

  case 132:
/* Line 1792 of yacc.c  */
#line 574 "sg.y"
    { ufdbSourceUserList( (yyvsp[(3) - (3)].string) ); }
    break;

  case 133:
/* Line 1792 of yacc.c  */
#line 575 "sg.y"
    { ufdbSourceExecUserList( (yyvsp[(2) - (2)].string) ); }
    break;

  case 134:
/* Line 1792 of yacc.c  */
#line 576 "sg.y"
    { ufdbSourceGroup( UFDB_GROUPTYPE_UNIX, (yyvsp[(2) - (2)].string) ); }
    break;

  case 135:
/* Line 1792 of yacc.c  */
#line 577 "sg.y"
    { ufdbSourceGroup( UFDB_GROUPTYPE_UNIX, (yyvsp[(2) - (2)].string) ); }
    break;

  case 136:
/* Line 1792 of yacc.c  */
#line 578 "sg.y"
    { ufdbSourceGroup( UFDB_GROUPTYPE_UNIX, (yyvsp[(3) - (3)].string) ); }
    break;

  case 137:
/* Line 1792 of yacc.c  */
#line 579 "sg.y"
    { ufdbSourceGroup( UFDB_GROUPTYPE_UNIX, (yyvsp[(3) - (3)].string) ); }
    break;

  case 138:
/* Line 1792 of yacc.c  */
#line 580 "sg.y"
    { ufdbSourceUserQuota( (yyvsp[(2) - (4)].string), (yyvsp[(3) - (4)].string), "3600" );  
		                                   ufdbFree( (yyvsp[(2) - (4)].string) ); ufdbFree( (yyvsp[(3) - (4)].string) ); }
    break;

  case 139:
/* Line 1792 of yacc.c  */
#line 582 "sg.y"
    { ufdbSourceUserQuota( (yyvsp[(2) - (4)].string), (yyvsp[(3) - (4)].string), "86400" );  
		                                   ufdbFree( (yyvsp[(2) - (4)].string) ); ufdbFree( (yyvsp[(3) - (4)].string) ); }
    break;

  case 140:
/* Line 1792 of yacc.c  */
#line 584 "sg.y"
    { ufdbSourceUserQuota( (yyvsp[(2) - (4)].string), (yyvsp[(3) - (4)].string), "604800" );  
		                                   ufdbFree( (yyvsp[(2) - (4)].string) ); ufdbFree( (yyvsp[(3) - (4)].string) ); }
    break;

  case 141:
/* Line 1792 of yacc.c  */
#line 586 "sg.y"
    { ufdbSourceUserQuota( (yyvsp[(2) - (4)].string), (yyvsp[(3) - (4)].string), (yyvsp[(4) - (4)].string) );  
		                                   ufdbFree( (yyvsp[(2) - (4)].string) ); ufdbFree( (yyvsp[(3) - (4)].string) ); ufdbFree( (yyvsp[(4) - (4)].string) ); }
    break;

  case 143:
/* Line 1792 of yacc.c  */
#line 589 "sg.y"
    { defSourceIpList( (yyvsp[(2) - (2)].string) ); }
    break;

  case 144:
/* Line 1792 of yacc.c  */
#line 590 "sg.y"
    { defSourceIpList( (yyvsp[(2) - (2)].string) ); }
    break;

  case 145:
/* Line 1792 of yacc.c  */
#line 591 "sg.y"
    { defSourceTime( (yyvsp[(2) - (2)].string), UFDB_ACL_WITHIN ); }
    break;

  case 146:
/* Line 1792 of yacc.c  */
#line 592 "sg.y"
    { defSourceTime( (yyvsp[(2) - (2)].string), UFDB_ACL_OUTSIDE ); }
    break;

  case 147:
/* Line 1792 of yacc.c  */
#line 593 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(3) - (3)].string) ); 
						   ufdbFree( (yyvsp[(3) - (3)].string) ); }
    break;

  case 148:
/* Line 1792 of yacc.c  */
#line 595 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(3) - (3)].string) ); 
						   ufdbFree( (yyvsp[(3) - (3)].string) ); }
    break;

  case 149:
/* Line 1792 of yacc.c  */
#line 597 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(2) - (2)].string) ); 
						   ufdbFree( (yyvsp[(2) - (2)].string) ); }
    break;

  case 150:
/* Line 1792 of yacc.c  */
#line 599 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(2) - (2)].string) ); 
						   ufdbFree( (yyvsp[(2) - (2)].string) ); }
    break;

  case 151:
/* Line 1792 of yacc.c  */
#line 601 "sg.y"
    { lastSource->cont_search = 1; }
    break;

  case 153:
/* Line 1792 of yacc.c  */
#line 607 "sg.y"
    { defSourceDomain( (yyvsp[(2) - (2)].string) ); }
    break;

  case 154:
/* Line 1792 of yacc.c  */
#line 608 "sg.y"
    { defSourceDomain( (yyvsp[(2) - (2)].string) ); }
    break;

  case 157:
/* Line 1792 of yacc.c  */
#line 614 "sg.y"
    { ufdbSourceUser( (yyvsp[(2) - (2)].string) ); }
    break;

  case 158:
/* Line 1792 of yacc.c  */
#line 615 "sg.y"
    { ufdbSourceUser( (yyvsp[(2) - (2)].string) ); }
    break;

  case 163:
/* Line 1792 of yacc.c  */
#line 628 "sg.y"
    { sgAcl( (yyvsp[(1) - (2)].string), NULL, UFDB_ACL_NONE );  }
    break;

  case 164:
/* Line 1792 of yacc.c  */
#line 629 "sg.y"
    { sgAcl( (yyvsp[(1) - (4)].string), (yyvsp[(3) - (4)].string), UFDB_ACL_WITHIN );  }
    break;

  case 165:
/* Line 1792 of yacc.c  */
#line 630 "sg.y"
    { sgAcl( (yyvsp[(1) - (4)].string), (yyvsp[(3) - (4)].string), UFDB_ACL_OUTSIDE ); }
    break;

  case 167:
/* Line 1792 of yacc.c  */
#line 636 "sg.y"
    { sgAcl( NULL, NULL, UFDB_ACL_ELSE );    }
    break;

  case 171:
/* Line 1792 of yacc.c  */
#line 646 "sg.y"
    { }
    break;

  case 172:
/* Line 1792 of yacc.c  */
#line 647 "sg.y"
    { sgAclSetValue( "rewrite", (yyvsp[(2) - (2)].string), 0 ); }
    break;

  case 173:
/* Line 1792 of yacc.c  */
#line 648 "sg.y"
    { sgAclSetValue( "rewrite", (yyvsp[(2) - (2)].string), 0 ); }
    break;

  case 174:
/* Line 1792 of yacc.c  */
#line 649 "sg.y"
    { sgAclSetValue( "redirect", (yyvsp[(2) - (2)].string), 0 ); }
    break;

  case 175:
/* Line 1792 of yacc.c  */
#line 650 "sg.y"
    { sgAclSetValue( "redirect", (yyvsp[(2) - (2)].string), 0 ); }
    break;

  case 176:
/* Line 1792 of yacc.c  */
#line 651 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(3) - (3)].string) ); 
						  ufdbFree( (yyvsp[(3) - (3)].string) ); }
    break;

  case 177:
/* Line 1792 of yacc.c  */
#line 653 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(3) - (3)].string) ); 
						  ufdbFree( (yyvsp[(3) - (3)].string) ); }
    break;

  case 178:
/* Line 1792 of yacc.c  */
#line 655 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(2) - (2)].string) ); 
						  ufdbFree( (yyvsp[(2) - (2)].string) ); }
    break;

  case 179:
/* Line 1792 of yacc.c  */
#line 657 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(2) - (2)].string) ); 
						  ufdbFree( (yyvsp[(2) - (2)].string) ); }
    break;

  case 181:
/* Line 1792 of yacc.c  */
#line 663 "sg.y"
    { yyerror( "\"aggressive\" is a keyword and must be surrounded by quotes" ); }
    break;

  case 182:
/* Line 1792 of yacc.c  */
#line 664 "sg.y"
    { sgAclSetValue( "pass", (yyvsp[(2) - (2)].string), 1 ); }
    break;

  case 183:
/* Line 1792 of yacc.c  */
#line 665 "sg.y"
    { yyerror( "\"aggressive\" is a keyword and must be surrounded by quotes" ); }
    break;

  case 184:
/* Line 1792 of yacc.c  */
#line 666 "sg.y"
    { sgAclSetValue( "pass", (yyvsp[(3) - (3)].string), 0 ); }
    break;

  case 186:
/* Line 1792 of yacc.c  */
#line 671 "sg.y"
    { sgIp( (yyvsp[(1) - (1)].string) ); ufdbFree( (yyvsp[(1) - (1)].string) ); }
    break;

  case 187:
/* Line 1792 of yacc.c  */
#line 675 "sg.y"
    { sgIp( (yyvsp[(1) - (1)].string) ); ufdbFree( (yyvsp[(1) - (1)].string) ); }
    break;

  case 189:
/* Line 1792 of yacc.c  */
#line 680 "sg.y"
    { sgIp( "255.255.255.255" );  sgSetIpType( SG_IPTYPE_HOST, NULL, 0 ); }
    break;

  case 190:
/* Line 1792 of yacc.c  */
#line 681 "sg.y"
    { sgSetIpType( SG_IPTYPE_CIDR, NULL, 0 ); }
    break;

  case 191:
/* Line 1792 of yacc.c  */
#line 682 "sg.y"
    { sgSetIpType( SG_IPTYPE_CLASS, NULL, 0 ); }
    break;

  case 192:
/* Line 1792 of yacc.c  */
#line 683 "sg.y"
    { sgSetIpType( SG_IPTYPE_RANGE, NULL, 0 ); }
    break;

  case 194:
/* Line 1792 of yacc.c  */
#line 688 "sg.y"
    { sgIp( (yyvsp[(1) - (1)].string) );  ufdbFree( (yyvsp[(1) - (1)].string) );  }
    break;

  case 195:
/* Line 1792 of yacc.c  */
#line 692 "sg.y"
    { sgRewrite( (yyvsp[(2) - (2)].string) ); }
    break;

  case 196:
/* Line 1792 of yacc.c  */
#line 693 "sg.y"
    { sgRewrite( (yyvsp[(2) - (2)].string) ); }
    break;

  case 200:
/* Line 1792 of yacc.c  */
#line 707 "sg.y"
    { sgRewriteSubstitute( (yyvsp[(1) - (1)].string) ); ufdbFree( (yyvsp[(1) - (1)].string) ); }
    break;

  case 201:
/* Line 1792 of yacc.c  */
#line 708 "sg.y"
    { sgRewriteTime( (yyvsp[(2) - (2)].string), UFDB_ACL_WITHIN ); }
    break;

  case 202:
/* Line 1792 of yacc.c  */
#line 709 "sg.y"
    { sgRewriteTime( (yyvsp[(2) - (2)].string), UFDB_ACL_OUTSIDE ); }
    break;

  case 203:
/* Line 1792 of yacc.c  */
#line 710 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(3) - (3)].string) );
						  ufdbFree( (yyvsp[(3) - (3)].string) ); }
    break;

  case 204:
/* Line 1792 of yacc.c  */
#line 712 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(3) - (3)].string) );
						  ufdbFree( (yyvsp[(3) - (3)].string) ); }
    break;

  case 205:
/* Line 1792 of yacc.c  */
#line 714 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(2) - (2)].string) );
						  ufdbFree( (yyvsp[(2) - (2)].string) ); }
    break;

  case 206:
/* Line 1792 of yacc.c  */
#line 716 "sg.y"
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[(2) - (2)].string) );
						  ufdbFree( (yyvsp[(2) - (2)].string) ); }
    break;

  case 207:
/* Line 1792 of yacc.c  */
#line 722 "sg.y"
    { sgTime( (yyvsp[(2) - (2)].string) ); }
    break;

  case 211:
/* Line 1792 of yacc.c  */
#line 736 "sg.y"
    { sgTimeElementInit(); }
    break;

  case 212:
/* Line 1792 of yacc.c  */
#line 736 "sg.y"
    { sgTimeElementAdd((yyvsp[(3) - (3)].string),T_WEEKDAY); }
    break;

  case 214:
/* Line 1792 of yacc.c  */
#line 737 "sg.y"
    { sgTimeElementInit(); }
    break;

  case 215:
/* Line 1792 of yacc.c  */
#line 737 "sg.y"
    { sgTimeElementAdd((yyvsp[(3) - (3)].string),T_WEEKLY); }
    break;

  case 217:
/* Line 1792 of yacc.c  */
#line 738 "sg.y"
    { sgTimeElementInit(); }
    break;

  case 218:
/* Line 1792 of yacc.c  */
#line 738 "sg.y"
    { sgTimeElementAdd((yyvsp[(3) - (3)].string),T_WEEKLY); }
    break;

  case 220:
/* Line 1792 of yacc.c  */
#line 739 "sg.y"
    { sgTimeElementInit(); }
    break;

  case 221:
/* Line 1792 of yacc.c  */
#line 739 "sg.y"
    { sgTimeElementEnd(); }
    break;

  case 222:
/* Line 1792 of yacc.c  */
#line 740 "sg.y"
    { ufdbLogFatalError( "invalid time specification at line %d", lineno );   }
    break;

  case 223:
/* Line 1792 of yacc.c  */
#line 744 "sg.y"
    { sgTimeElementClone(); }
    break;

  case 232:
/* Line 1792 of yacc.c  */
#line 757 "sg.y"
    { sgTimeElementAdd( (yyvsp[(1) - (1)].string), T_DVAL ); }
    break;

  case 233:
/* Line 1792 of yacc.c  */
#line 760 "sg.y"
    { sgTimeElementAdd( (yyvsp[(1) - (1)].tval), T_TVAL ); }
    break;

  case 234:
/* Line 1792 of yacc.c  */
#line 763 "sg.y"
    { sgTimeElementAdd( (yyvsp[(1) - (1)].string), T_DVALCRON ); }
    break;

  case 235:
/* Line 1792 of yacc.c  */
#line 767 "sg.y"
    {  yyerror( "syntax error" );  }
    break;


/* Line 1792 of yacc.c  */
#line 3414 "y.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 833 "sg.y"


int sgReadConfig( 
   char *      file )
{
   char *      defaultFile = DEFAULT_CONFIGFILE;
   struct Source * source;

   lineno = 1;
   ufdbResetCPUs();

   UFDBglobalConfigFile = file;
   if (UFDBglobalConfigFile == NULL)
      UFDBglobalConfigFile = defaultFile;

   yyin = fopen( UFDBglobalConfigFile, "r" );
   if (yyin == NULL) 
   {
      syslog( LOG_ALERT, "%s: cannot open configuration file %s", progname, UFDBglobalConfigFile );
      ufdbLogFatalError( "cannot open configuration file %s", UFDBglobalConfigFile );
      return 0;
   }

   ufdbLogMessage( "configuration file: %s", UFDBglobalConfigFile );

   strcpy( UFDBglobalRedirectHttps, UFDB_DEFAULT_HTTPS_REDIRECTION_URL );
   /* UFDBglobalDebug = 0; */
   strcpy( UFDBglobalInterface, "all" );
   /* UFDBglobalPortNum = UFDB_DAEMON_PORT;  the port can be set with a command line switch so do not reset it */
   UFDBglobalDebugHttpd = 0;
   UFDBglobalLogBlock = 0;
   UFDBglobalLogPass = 0;
   UFDBglobalLogAllRequests = 0;
   UFDBglobalYoutubeEdufilter = 0;
   UFDBglobalYoutubeEdufilterID = "none";
   UFDBglobalAllowGoogleHTTPSusingIP = 0;

#if 0
   /* When a database is reloaded, these variables may NOT be reset since they are used during the reload !! */
   UFDBglobalURLlookupDelayDBreload = 0;
   UFDBglobalURLlookupResultDBreload = UFDB_ALLOW;
   UFDBglobalURLlookupResultFatalError = UFDB_ALLOW;
   /* strcpy( UFDBglobalLoadingDatabaseRedirect, "a-blocking-url" ); */
   ufdbFree( UFDBglobalSquidVersion );
#endif
   if (UFDBglobalSquidVersion == NULL)
      UFDBglobalSquidVersion = ufdbStrdup( UFDB_DEFAULT_SQUID_VERSION );

   UFDBglobalShowURLdetails = 0;
   UFDBglobalDebugSkype = 0;
   UFDBglobalDebugGtalk = 0;
   UFDBglobalDebugYahooMsg = 0;
   UFDBglobalDebugAim = 0;
   UFDBglobalDebugFBchat = 0;
   UFDBglobalDebugCitrixOnline = 0;
   UFDBglobalDebugRegexp = 0;
   UFDBglobalDebugExternalScripts = 0;
   UFDBglobalExpressionOptimisation = 1;
   UFDBglobalRefreshUserlistInterval = UFDB_DEFAULT_REFRESH_USERLIST;
   UFDBglobalRefreshDomainlistInterval = UFDB_DEFAULT_REFRESH_DOMAINLIST;
   if (UFDBglobalAnalyseUncategorisedURLs >= 0)		/* obey -N option which uses value -1 */
      UFDBglobalAnalyseUncategorisedURLs = 1;
   UFDBglobalLogUncategorisedURLs = 0;
   UFDBglobalUploadStats = 1;
   UFDBglobalSafeSearch = 1;
   UFDBglobalStripDomainFromUsername = 0;
   UFDBglobalTunnelCheckMethod = UFDB_API_HTTPS_CHECK_OFF;
   UFDBglobalSquidUsesSSLbump = 0;
   UFDBglobalHttpsWithHostname = 0;
   UFDBglobalHttpsOfficialCertificate = 0;
   UFDBglobalUnknownProtocolOverHttps = 1;
   UFDBglobalHttpsNoSSLv2 = 0;
   UFDBglobalHttpdPort = 0;
   strcpy( UFDBglobalHttpdInterface, "all" );
   strcpy( UFDBglobalHttpdImagesDirectory, "." );
 
   UFDBglobalDatabaseStatus = UFDB_API_STATUS_DATABASE_OK;

   (void) yyparse();
   fclose( yyin );

   UFDBglobalDatabaseLoadTime = time( NULL );

   /*
    * For analysis of uncategorised URLs we also load a "checked" category
    * that contains URLs that are reviewed and checked not to be part of
    * any other category.
    */
   {
      char * dbhome;
      char   dbfname[1024];

      dbhome = ufdbSettingGetValue( "dbhome" );
      if (dbhome == NULL)
         dbhome = DEFAULT_DBHOME;

      if (UFDBglobalAnalyseUncategorisedURLs > 0)
      {
	 sprintf( dbfname, "%s/checked/domains.ufdb", dbhome );
	 if (UFDBloadDatabase( &UFDBglobalCheckedDB, dbfname ) != UFDB_API_OK)
	 {
	    UFDBglobalCheckedDB.mem = NULL;
	    UFDBglobalCheckedDB.index = NULL;
	    UFDBglobalCheckedDB.table.nNextLevels = 0;
	    if (UFDBglobalDebug)
	       ufdbLogMessage( "The URL database appears not be from URLfilterDB. No problem." );
	 }
	 else
	 {
	    sprintf( dbfname, "%s/checked/expressions", dbhome );
	    (void) UFDBloadExpressions( &UFDBglobalCheckedExpressions, dbfname );
	    ufdbLogMessage( "a sample of uncategorised URLs will be analysed." );
	 }
      }
   }

   if (defaultAcl == NULL)
      ufdbLogFatalError( "\"default\" ACL is not defined" );
   else if (defaultAcl->pass == NULL)
      ufdbLogError( "\"default\" ACL is empty: by default all URLs are blocked." );

   /* A configuration file may have a source definition which is not used in the ACL list.
    * This raises the question "what to do with this ?".
    * If we do nothing, the source is matched but has no ACL definition and is silently skipped.
    * Most likely the administrator overlooked something so a warning is useful.
    */
   source = UFDBgetSourceList();  
   if (source == NULL  &&  defaultAcl == NULL)
      ufdbLogFatalError( "There are no sources and there is no default ACL" );

   for ( ; source != NULL;  source = source->next)
   {
      int          found;
      struct Acl * acl;

      found = 0;
      for (acl = AclList;  acl != NULL;  acl = acl->next)
      {
         if (strcmp( acl->name, source->name ) == 0)
	 {
	    found = 1;
	    break;
	 }
      }
      if (!found)
      {
         ufdbLogError( "source \"%s\" has no ACL so it is not used  *****", source->name );
	 source->active = 0;
      }
      else if (acl->pass == NULL)
      {
         ufdbLogMessage( "source \"%s\" has an empty \"pass\" in its ACL  *****", source->name );
      }
   }

   if (UFDBglobalAdminEmail != NULL  &&  UFDBglobalEmailServer == NULL)
   {
      ufdbLogError( "No email server is defined; cannot send email to %s  *****", UFDBglobalAdminEmail );
   }

   if (strncmp( UFDBglobalSquidVersion, "3.5", 3 ) != 0  &&
       strncmp( UFDBglobalSquidVersion, "3.4", 3 ) != 0  &&
       strncmp( UFDBglobalSquidVersion, "3.3", 3 ) != 0  &&
       strncmp( UFDBglobalSquidVersion, "3.2", 3 ) != 0  &&
       strncmp( UFDBglobalSquidVersion, "3.1", 3 ) != 0  &&
       strncmp( UFDBglobalSquidVersion, "3.0", 3 ) != 0  &&
       strncmp( UFDBglobalSquidVersion, "2.7", 3 ) != 0  &&
       strncmp( UFDBglobalSquidVersion, "2.6", 3 ) != 0)
   {
      ufdbLogFatalError( "Unsupported Squid version \"%s\"  *****\n"
                         "The supported values for squid-version are: 3.5, 3.4, 3.3, 3.2, 3.1, 3.0, 2.7, 2.6  *****\n"
                         "If the version of Squid is higher, it is recommended to upgrade ufdbGuard.  *****\n"
                         "Alternatively set squid-version to the highest supported version",
                         UFDBglobalSquidVersion );
   }
   if (strncmp( UFDBglobalSquidVersion, "3.5", 3 ) == 0  ||  strncmp( UFDBglobalSquidVersion, "3.4", 3 ) == 0)
      UFDBglobalSquidHelperProtocol = UFDB_SQUID_HELPER_PROTOCOL3;
   else if (strncmp( UFDBglobalSquidVersion, "2.6", 3 ) == 0  ||  strncmp( UFDBglobalSquidVersion, "2.7", 3 ) == 0)
      UFDBglobalSquidHelperProtocol = UFDB_SQUID_HELPER_PROTOCOL1;
   else
      UFDBglobalSquidHelperProtocol = UFDB_SQUID_HELPER_PROTOCOL2;      /* 3.0 - 3.3 */

   return 1;
}


static void setRefreshUserlist( int nmin )
{
   if (nmin < 5  ||  nmin > 24*60)
   {
      ufdbLogError( "refreshuserlist must have a value between 5 and %d, resetting to %d.", 24*60, UFDB_DEFAULT_REFRESH_USERLIST );
      nmin = UFDB_DEFAULT_REFRESH_USERLIST;
   }
   UFDBglobalRefreshUserlistInterval = nmin;
}


static void setRefreshDomainlist( int nmin )
{
   if (nmin < 5  ||  nmin > 24*60)
   {
      ufdbLogError( "refreshdomainlist must have a value between 5 and %d, resetting to %d.", 24*60, UFDB_DEFAULT_REFRESH_DOMAINLIST );
      nmin = UFDB_DEFAULT_REFRESH_DOMAINLIST;
   }
   UFDBglobalRefreshDomainlistInterval = nmin;
}


/*
 * Source functions
 */

void defSource( 
   char *          source )
{
   struct Source * sp;

   if (UFDBglobalDebug)
      ufdbLogMessage( "defSource: defining source \"%s\"", source );

   if ((struct Source *) defSourceFindName(source) != NULL)
   {
      ufdbLogFatalError( "line %d: source %s is already defined in configuration file %s",
			 lineno, source, UFDBglobalConfigFile );
      ufdbFree( source );
      return;
   }

   sp = (struct Source *) ufdbMalloc( sizeof(struct Source) );
   sp->name = source;
   sp->active = 1;
   sp->ip = NULL;
   sp->lastip = NULL;
   sp->domainDb = NULL;
   sp->userDb = NULL;
   sp->time = NULL;
   sp->within = UFDB_ACL_NONE;
   sp->nblocks = 0;
   sp->cont_search = 0;
   sp->sarg0 = NULL;
   sp->userquota.seconds = 0;
   sp->userquota.renew = 0;
   sp->userquota.sporadic = 0;
   sp->next = NULL;

   if (UFDBgetSourceList() == NULL)
   {
      if (UFDBglobalDebug)
         ufdbLogMessage( "defSource: SourceList is set to point to \"%s\"", source );
      UFDBsetSourceList( sp );
      lastSource = sp;
   }
   else
   {
      lastSource->next = sp;
      lastSource = sp;
   }
}


void defSourceEnd( void )
{
  struct Source * s;

  s = lastSource;
  if (s->ip == NULL  &&  s->domainDb == NULL  &&  s->userDb == NULL)
  {
    ufdbLogError( "source \"%s\" missing active content, set inactive", s->name );
    s->time = NULL;
    s->active = 0;
  }
}


void ufdbSourceUser( 
  char *               user )
{
  char *               lc;
  struct Source *      sp;
  struct UserQuotaInfo q;

  sp = lastSource;
  if (sp->userDb == NULL)
  {
    sp->userDb = ufdbMalloc( sizeof(struct sgDb) );
    sp->userDb->dbhome = NULL;
    sp->userDb->dbcp = (void *) UFDBmemDBinit();
    sp->userDb->type = SGDBTYPE_USERLIST;
    sp->userDb->entries = 0;
  }

  for (lc = user; *lc != '\0'; lc++)    /* convert username to lowercase chars */
  {
    if (*lc >= 'A'  &&  *lc <= 'Z')
       *lc += 'a' - 'A';
  }

  sp->userDb->entries++;
  UFDBmemDBinsert( (struct UFDBmemDB *) sp->userDb->dbcp, user, (char *) setuserquota(&q),
	           sizeof(struct UserQuotaInfo) );
  ufdbFree( user );
}


static void ufdbSourceUnixGroup(
   char *          groupName  )
{
   struct Source * sp;
   struct group *  grp;
   int             n;
   char *          user;

   sp = lastSource;
   if (sp->userDb == NULL) 
   {
      sp->userDb = ufdbMalloc( sizeof(struct sgDb) );
      sp->userDb->dbhome = NULL;
      sp->userDb->dbcp = (void *) UFDBmemDBinit();
      sp->userDb->type = SGDBTYPE_USERLIST;
      sp->userDb->entries = 0;
   }
 
   n = 0;

   setgrent();
   errno = 0;
   grp = getgrnam( groupName );
   if (grp != NULL)
   {
      if (UFDBglobalDebug > 1)
         ufdbLogMessage( "found group \"%s\"", grp->gr_name );

      while ((user = grp->gr_mem[n]) != NULL)
      {
	 char * lc;
	 struct UserQuotaInfo q;

	 if (UFDBglobalDebug > 1)
	    ufdbLogMessage( "group \"%s\" has user \"%s\"", grp->gr_name, user );
	 for (lc = user; *lc != '\0'; lc++)  	/* convert username to lowercase chars */
	 {
	   if (*lc >= 'A'  &&  *lc <= 'Z')
	      *lc += 'a' - 'A';
	 }
	 UFDBmemDBinsert( (struct UFDBmemDB *) sp->userDb->dbcp, user, (char *) setuserquota(&q),
			  sizeof(struct UserQuotaInfo) );
	 n++;
      }
      sp->userDb->entries = n;
      ufdbLogMessage( "source \"%s\": unix group \"%s\" has %d members", sp->name, groupName, n );
      if (n == 0)
	 ufdbLogMessage( "WARNING: source \"%s\": \"%s\" is an empty group", sp->name, groupName );
   }
   else
   {
      ufdbLogFatalError( "source \"%s\": \"%s\" is not a unix group", sp->name, groupName );
      if (errno)
	 ufdbLogError( "ufdbSourceUnixGroup: getgrnam returned error %d: %s", errno, strerror(errno) );
   }
   endgrent();
}


static void ufdbSourceGroup( 
   int    groupType,
   char * groupName  )
{
   switch (groupType)
   {
   case UFDB_GROUPTYPE_UNIX:
      ufdbSourceUnixGroup( groupName );
      break;
   default:     
      ufdbLogFatalError( "ufdbSourceGroup: unknown group type %d", groupType );
   }

   ufdbFree( groupName );
}


struct sgDb * UFDBretrieveExecUserlist( char * command )
{
   int           ullineno;
   FILE *        fp;
   struct sgDb * newdb;
   char *        lc;
   struct UserQuotaInfo q;
   char          line[10000];

   if (UFDBglobalTerminating)
      return NULL;

   newdb = ufdbMalloc( sizeof(struct sgDb) );
   newdb->dbhome = NULL;
   newdb->dbcp = (void *) UFDBmemDBinit();
   newdb->type = SGDBTYPE_EXECUSERLIST;

   errno = 0;
   if ((fp = popen(command,"r")) == NULL)
   {
      ufdbLogFatalError( "line %d: can't execute command of execuserlist \"%s\": %s  *****", lineno, command, strerror(errno) );
      return NULL;
   }
   ullineno = 0;

   while (UFDBfgetsNoNL(line,sizeof(line),fp) != NULL)
   {
      ullineno++;

      if (UFDBglobalDebug || UFDBglobalDebugExternalScripts)
         ufdbLogMessage( "   execuserlist: received \"%s\"", line );

      if (line[0] == '#')			/* skip comments */
         continue;

      if (line[0] == '\0')
      {
         ufdbLogError( "execuserlist \"%s\": line %d: line is empty", command, ullineno );
         continue;
      }

      for (lc = line;  *lc != '\0';  lc++)   /* convert username to lowercase chars */
      {
	 if (*lc >= 'A'  &&  *lc <= 'Z')
	    *lc += 'a' - 'A';
      }
      UFDBmemDBinsert( (struct UFDBmemDB *) newdb->dbcp, line, (char *) setuserquota(&q),
		       sizeof(struct UserQuotaInfo) );
   }
   (void) pclose( fp );

   newdb->entries = ullineno;
   ufdbLogMessage( "finished retrieving userlist \"%s\" (%d lines)", command, ullineno );

   return newdb;
}


struct sgDb * UFDBretrieveExecDomainlist( struct Category * cat )
{
   char *        t;
   FILE *        fp;
   struct sgDb * newdb;
   int           exitcode;
   struct stat   Stat0;
   struct stat   Stat1;
   char          line[1024];
   char          basefilename[1024];
   char          fullfilename[1024];
   char          command[3000];

   if (cat == NULL)
   {
      ufdbLogFatalError( "UFDBretrieveExecDomainlist: category is NULL" );
      return NULL;
   }

   if (cat->domainlist == NULL)
   {
      ufdbLogError( "will not execute command for category %s since domainlist is undefined", cat->name );
      return NULL;
   }

   if (cat->execdomainlist == NULL)
   {
      ufdbLogError( "can't execute command for category %s since execdomainlist is undefined", cat->name );
      return NULL;
   }

   if (cat->domainlist[0] == '/')
   {
      strcpy( basefilename, cat->domainlist );
   }
   else
   {
      char * dbhome;
      dbhome = ufdbSettingGetValue( "dbhome" );
      if (dbhome == NULL)
	 dbhome = DEFAULT_DBHOME;
      sprintf( basefilename, "%s/%s", dbhome, cat->domainlist );
   }
   strcpy( fullfilename, basefilename );
   strcat( fullfilename, UFDBfileSuffix );

   if (stat( fullfilename, &Stat0 ) != 0)
   {
      Stat0.st_mtime = 0;
      ufdbLogMessage( "category %s: pre-execdomainlist: domainlist does not exist (%s)", cat->name, fullfilename );
   }

   /* The script that we will call needs the directory where the files reside,
    * so we set the environment variable UFDB_TABLEDIR for it to change its working directory.
    * (note that we are multithreaded and cannot use chdir() here)
    */
   strcpy( command, "cd " );
   strcat( command, basefilename );
   t = strrchr( command, '/' );
   if (t != NULL)
      *t = '\0';
   strcat( command, " ; " );
   strcat( command, cat->execdomainlist );

   errno = 0;
   if ((fp = popen(command,"r")) == NULL)
   {
      ufdbLogFatalError( "category %s: can't execute command of execdomainlist \"%s\": popen failed: %s  *****", cat->name, cat->execdomainlist, strerror(errno) );
      return NULL;
   }

   while (UFDBfgetsNoNL(line,sizeof(line),fp) != NULL)
   {
      ufdbLogMessage( "execuserlist for %s produced: %s", cat->name, line );
   }
   errno = 0;
   exitcode = pclose( fp );

   if (exitcode == -1  &&  errno == ECHILD)
      exitcode = 0;
      /* most likely the child handler thread already did a wait() */

   if (exitcode == 0)
   {
      if (UFDBglobalDebug || UFDBglobalDebugExternalScripts)
         ufdbLogMessage( "   execdomainlist for %s: exit 0 (OK)", cat->name );
   }
   else if (exitcode == -1)
   {
      ufdbLogError( "execuserlist for %s: pclose error: %d (%s)", cat->name, errno, strerror(errno) );
      return NULL;
   }
   else if (exitcode > 0)
   {
      ufdbLogError( "execuserlist for %s: command (%s) terminated with an error exit code %d", 
                    cat->name, cat->execdomainlist, exitcode );
      return NULL;
   }

   /* The command defined by 'execdomainlist' has been executed and the exit code was 0 (OK), so
    * now it is verified if the file timestamp of domains.ufdb is newer.
    */

   if (stat( fullfilename, &Stat1 ) != 0)
   {
      ufdbLogError( "execdomainlist for %s: command failed to produce a .ufdb file (%s)", cat->name, fullfilename );
      return NULL;
   }

   newdb = ufdbCalloc( sizeof(struct sgDb), 1 );
   newdb->dbhome = NULL;
   newdb->dbcp = NULL;
   newdb->type = SGDBTYPE_DOMAINLIST;

   sgDbInit( newdb, basefilename );
   if (newdb->dbcp == NULL)
   {
      ufdbLogError( "execdomainlist for %s: command produced a .ufdb file but I failed to load it", cat->name );
      ufdbFree( newdb );
      return NULL;
   }

   if (UFDBglobalDebug || UFDBglobalDebugExternalScripts)
      ufdbLogMessage( "execdomainlist for %s: new URL table is loaded", cat->name );

   return newdb;
}


void ufdbSourceExecUserList(
   char * command )
{
   struct Source * sp;

   /* execuserlist is used to dynamically retrieve a list of usernames and
    * is executed every 15 minutes to refresh the list of usernames.
    */

   ufdbLogMessage( "execuserlist \"%s\"", command );

   sp = lastSource;
   sp->userDb = UFDBretrieveExecUserlist( command );
   sp->sarg0 = command;				/* command is already malloc-ed */
 
   if (UFDBglobalDebug || UFDBglobalDebugExternalScripts)
   {
      UFDBmemDBprintUserDB( (struct UFDBmemDB *) sp->userDb->dbcp );
   }
}


void ufdbSourceUserList( 
  char * file  )
{
  char * dbhome;
  char * f;
  FILE * fp;
  char * p;
  char * c;
  char * s;
  char * lc;
  char * lineptr;
  int    ullineno;
  struct sgDb * udb;
  struct Source * sp;
  struct UserQuotaInfo q;
  char   line[10000];

  sp = lastSource;
  udb = sp->userDb;
  if (udb == NULL) 
  {
    udb = sp->userDb = ufdbMalloc( sizeof(struct sgDb) );
    udb->dbhome = NULL;
    udb->dbcp = (void *) UFDBmemDBinit();
    udb->type = SGDBTYPE_USERLIST;
    udb->entries = 0;
  }
 
  dbhome = ufdbSettingGetValue( "dbhome" );
  if (dbhome == NULL)
    dbhome = DEFAULT_DBHOME;

  if (file[0] == '/')
    f = file;
  else
  {
    f = (char *) ufdbMalloc( strlen(dbhome) + strlen(file) + 2 );
    strcpy( f, dbhome );
    strcat( f, "/" );
    strcat( f, file );
    ufdbFree( file );
  }

  if ((fp = fopen(f,"r")) == NULL)
  {
    ufdbLogError( "line %d: can't open userlist %s: %s  *****", lineno, f, strerror(errno) );
    ufdbFree( f );
    return;
  }
  ullineno = 0;

  ufdbLogMessage( "userlist \"%s\"", f );

  while (fgets(line,sizeof(line),fp) != NULL)
  {
    ullineno++;
    if (line[0] == '#')			/* skip comments */
      continue;

    p = strchr( line, '\n' );
    if (p != NULL)
    {
      *p = '\0';
      if (p != line) 
      {
	 if (*(p - 1) == '\r') 		/* remove ^M  */
	   *(p-1) = '\0';
      }
    }

    if (line[0] == '\0')
    {
       ufdbLogError( "userlist %s: line %d: line is empty", f, ullineno );
       continue;
    }

    c = strchr( line, '#' );		/* remove comment */
    if (c != NULL)
       *c = '\0';

    p = strtok_r( line, " \t,", &lineptr );
    if (p == NULL  ||  *p == '\0')
       continue;

    /* we may have a passwd-style formatted file. Ignore ':' and everything else that follows. */
    if ((s = strchr(p,':')) != NULL) 
      *s = '\0';

    do {
       for (lc = p;  *lc != '\0';  lc++)   /* convert username to lowercase chars */
       {
	  if (*lc >= 'A'  &&  *lc <= 'Z')
	     *lc += 'a' - 'A';
       }
       if (*p != '\0')
	  UFDBmemDBinsert( (struct UFDBmemDB *) udb->dbcp, p, (char *) setuserquota(&q),
			   sizeof(struct UserQuotaInfo) );
    } while ((p = strtok_r(NULL," \t,",&lineptr)) != NULL  &&  *p != '\0');
  }
  fclose( fp );

   if (UFDBglobalDebug)
   {
      ufdbLogMessage( "just read userlist %s", f );
      UFDBmemDBprintUserDB( (struct UFDBmemDB *) udb->dbcp );
   }

   ufdbFree( f );
}


static void ufdbSourceUserQuota( 
   char * seconds, 
   char * sporadic,  
   char * renew )
{
   int    s;
   struct UserQuota * uq;
   struct Source * sp;
 
   sp = lastSource;
   uq = &sp->userquota;
   s = atoi( seconds );
   if (s <= 0)
      ufdbLogError( "line %d: userquota seconds sporadic hourly|daily|weekly", lineno );
   uq->seconds = s; 
   s = atoi( sporadic );
   if (s <= 0)
      ufdbLogError( "line %d: userquota seconds sporadic hourly|daily|weekly", lineno );
   uq->sporadic = s; 
   s = atoi( renew );
   if (s <= 0)
      ufdbLogError( "line %d: userquota seconds sporadic hourly|daily|weekly", lineno );
   uq->renew = s;
}


void defSourceDomain( 
   char * domain )
{
   struct Source * sp;
   struct UserQuotaInfo q;

   sp = lastSource;
   if (sp->domainDb == NULL) 
      sp->domainDb = (struct sgDb *) UFDBmemDBinit();

   if (UFDBglobalDebug)
      ufdbLogMessage( "defSourceDomain \"%s\"", domain );

   UFDBmemDBinsert( (struct UFDBmemDB *) sp->domainDb, domain, (char *) setuserquota(&q), sizeof(struct UserQuotaInfo) );

   ufdbFree( domain );
}


void defSourceTime( 
   char *         name, 
   int            within )
{
   struct ufdbTime *  t;

   if ((t = sgTimeFindName(name)) == NULL)
   {
      ufdbLogFatalError( "line %d: time \"%s\" is not defined in configuration file %s",
		         lineno, name, UFDBglobalConfigFile );
      ufdbFree( name );
      return;
   }

   lastSource->within = within;
   lastSource->time = t;
   ufdbFree( name );
}


struct Source * defSourceFindName( 
   char *          name )
{
   struct Source * p;

   for (p = UFDBgetSourceList();  p != NULL;  p = p->next)
   {
      if (strcmp(name,p->name) == 0)
         return p;
   }

   return NULL;
}


void defSourceIpList( 
  char * file )
{
  char * dbhome = NULL;
  char * f;
  FILE * fp;
  char * p;
  char * c;
  char * cidr;
  int    i;
  int    l = 0;
  char * lineptr;
  char   line[UFDB_MAX_URL_LENGTH];

  dbhome = ufdbSettingGetValue( "dbhome" );
  if (dbhome == NULL)
    dbhome = DEFAULT_DBHOME;

  if (file[0] == '/') 
  {
    f = file;
  }
  else
  {
    f = (char *) ufdbMalloc( strlen(dbhome) + strlen(file) + 2 );
    strcpy( f, dbhome );
    strcat( f, "/" );
    strcat( f, file );
    ufdbFree( file );
  }

  if ((fp = fopen(f,"r")) == NULL) 
  {
    ufdbLogError( "line %d: can't open iplist %s: %s", lineno, f, strerror(errno) );
    ufdbFree( f );
    return;
  }

  ufdbLogMessage( "iplist \"%s\"", file );

  while (fgets(line,sizeof(line),fp) != NULL)
  {
    l++;
    if (*line == '#')
      continue;
    p = strchr( line, '\n' );
    if (p != NULL && p != line) 
    {
      if (*(p - 1) == '\r') 		/* removing ^M  */
	p--;
      *p = '\0';
    }
    c = strchr( line, '#' );
    p = strtok_r( line, " \t,", &lineptr );
    do {
      if (c != NULL && p >= c) 		/* find the comment */
	break;
      i = strspn( p, ".0123456789/-" );
      if (i == 0)
	break;
      *(p + i) = '\0';
      if ((cidr = strchr(p,'/')) != NULL) 
      {
	*cidr = '\0';
	cidr++;
	sgIp( p );
	sgIp( cidr );
	if (strchr(cidr,'.') == NULL)
	  sgSetIpType( SG_IPTYPE_CIDR, f, l );
	else 
	  sgSetIpType( SG_IPTYPE_CLASS, f, l );
      }
      else if ((cidr = strchr(p,'-')) != NULL) 
      {
	*cidr = '\0';
	cidr++;
	sgIp( p );
	sgIp( cidr );
	sgSetIpType( SG_IPTYPE_RANGE, f, l );
      }
      else
      {
	sgIp( p );
	sgIp( ufdbStrdup("255.255.255.255") );
	sgSetIpType( SG_IPTYPE_HOST, f, l );
      }
    } while ((p = strtok_r(NULL," \t,",&lineptr)) != NULL);
  }

  fclose( fp );
  ufdbFree( f );
}


/*
 *  called by main loop: find a source definition based on the user ident/domain/ip
 */
struct Source * UFDBfindSource( 
  struct Source *    allSrcs, 
  char *             net, 
  struct SquidInfo * si )
{
  struct Source *    s;
  struct Ip *        ip;
  int                founduser;
  unsigned long      i, octet, op;

  if (UFDBglobalFatalError  ||  UFDBglobalReconfig)
  {
#ifdef UFDB_DEBUG_ACL_ACCESS
     ufdbLogMessage( "   UFDBfindSource: fatal-error or reconfig: returning NULL" );
#endif
     return NULL;
  }

#if defined(UFDB_DEBUG_ACL_ACCESS)
  if (UFDBglobalDebug)
     ufdbLogMessage( "   UFDBfindSource '%s'  id '%s'  net '%s'", allSrcs==NULL ? "NULL" : allSrcs->name, si->ident, net == NULL ? "nonet" : net );
#endif

  if (allSrcs == NULL)
  {
     /* allSrcs may be NULL since we have a configuration with only the default rule */
     return NULL;
  }

  octet = 0;
  if (net != NULL)
  {
    if (sgConvDot(net,&op) != NULL)
      octet = op;
  }

  for (s = allSrcs;  s != NULL;  s = s->next)
  {
    if (s->active == 0)
    {
#if defined(UFDB_DEBUG_ACL_ACCESS)
       if (UFDBglobalDebug)
          ufdbLogMessage( "      source '%s' is inactive: skipped", s->name != NULL ? s->name : "noname" );
#endif
       continue;
    }

    founduser = 0;

    if (s->ip != NULL)
    {
      if (net == NULL)
	 ;
      else 
      {
	for (ip = s->ip;  ip != NULL;  ip = ip->next)
	{
	  if (!ip->net_is_set)
	     continue;

	  if (ip->type == SG_IPTYPE_RANGE) 
	  {
	    if (octet >= ip->net  &&  octet <= ip->mask) {
	      if (UFDBglobalDebug > 1)
		 ufdbLogMessage( "found ip in source %s", s->name==NULL ? "NULL" : s->name );
	      return s;
	    }
	  }
	  else				/* CIDR or HOST */
	  { 
	    i = octet & ip->mask;
	    if (i == ip->net) {
	      if (UFDBglobalDebug > 1)
		 ufdbLogMessage( "found ip in source %s", s->name==NULL ? "NULL" : s->name );
	      return s;
	    }
	  }
	}
      }
    }

#if defined(UFDB_DEBUG_ACL_ACCESS)
   if (UFDBglobalDebug)
      ufdbLogMessage( "   UFDBfindSource  '%s'  userDb = %08lx  foundip 0", s->name==NULL ? "nosrc" : s->name, (unsigned long) s->userDb );
#endif

    if (s->userDb != NULL)
    {
      if (si->ident[0] == '\0'  ||  (si->ident[0] == '-'  &&  si->ident[1] == '\0'))
      {
	 ;
      }
      else 
      {
        struct UserQuotaInfo * q = NULL;
	int ret;

	if (UFDBglobalDebug)
	   ufdbLogMessage( "matching user \"%s\" to userlist of \"%s\"", si->ident, s->name==NULL ? "NULL" : s->name );

        if (s->userDb->type == SGDBTYPE_EXECUSERLIST)
	{
#ifdef UFDB_HAVE_NATIVE_RWLOCK_MUTEX
	   ret = pthread_rwlock_rdlock( &TheDynamicSourcesLock );
	   if (ret != 0)
	      ufdbLogError( "UFDBfindSource: pthread_rwlock_rdlock TheDynamicSourcesLock failed with code %d", ret );
#else
	   ret = pthread_mutex_lock( &TheDynamicSourcesLock );
	   if (ret != 0)
	      ufdbLogError( "UFDBfindSource: pthread_mutex_lock TheDynamicSourcesLock failed with code %d", ret );
#endif
        }

	if (UFDBmemDBfind( (struct UFDBmemDB *) s->userDb->dbcp, si->ident, (char **) (char *) &q ) == 1)
	{
	  if (UFDBglobalDebug > 1)
	     ufdbLogMessage( "found user \"%s\" in userdb   q=%08lx", si->ident, (unsigned long) q );
	  founduser = 1;
	}

        if (s->userDb->type == SGDBTYPE_EXECUSERLIST)
	{
#ifdef UFDB_HAVE_NATIVE_RWLOCK_MUTEX
	   ret = pthread_rwlock_unlock( &TheDynamicSourcesLock );
	   if (ret != 0)
	      ufdbLogError( "UFDBfindSource: pthread_rwlock_unlock TheDynamicSourcesLock failed with code %d", ret );
#else
	   ret = pthread_mutex_unlock( &TheDynamicSourcesLock );
	   if (ret != 0)
	      ufdbLogError( "UFDBfindSource: pthread_mutex_unlock TheDynamicSourcesLock failed with code %d", ret );
#endif
        }

	if (founduser)
	   return s;
      }
    }

#if UFDB_USERQUOTA_SUPPORT || defined(UFDB_DEBUG_ACL_ACCESS)
   if (UFDBglobalDebug)
      ufdbLogMessage( "   UFDBfindSource  '%s'  userDb = %08lx  founduser %d", s->name==NULL ? "nosrc" : s->name, (unsigned long) s->userDb, founduser );
#endif

    if (s->domainDb != NULL)
    {
      if (si->srcDomain[0] == '\0'  ||  (si->srcDomain[0] == '-'  && si->srcDomain[1] == '\0'))
         ;
      else 
      {
	if (UFDBmemDBfindDomain( (struct UFDBmemDB *) s->domainDb, si->srcDomain ))
	{
	   if (UFDBglobalDebug > 1)
	      ufdbLogMessage( "found domain \"%s\" in srcDomain", si->srcDomain );
	   return s;
        }
      }
    }

#if defined(UFDB_DEBUG_ACL_ACCESS)
   if (UFDBglobalDebug)
      ufdbLogMessage( "   UFDBfindSource  '%s'  userDb = %08lx  founddomain 0", s->name==NULL ? "nosrc" : s->name, (unsigned long) s->userDb );
#endif
  }

  return NULL;
}


/* category block functions */

void ufdbCategory( 
  char *            cat )
{
  struct Category * sp;

#if defined(UFDB_DEBUG)
   ufdbLogMessage( "ufdbCategory %s", cat );
#endif

  if (Cat != NULL) 
  {
    if ((struct Category *) ufdbCategoryFindName(cat) != NULL)
    {
      ufdbLogFatalError( "line %d: category %s is already defined in configuration file %s",
		         lineno, cat, UFDBglobalConfigFile );
      ufdbFree( cat );
      return;
    }
  }

  sp = (struct Category *) ufdbMalloc( sizeof(struct Category) );
  sp->name = cat;
  sp->active = 1;
  sp->domainlist = NULL;
  sp->domainlistDb = NULL;
  sp->execdomainlist = NULL;
  sp->expressionlist = NULL;
  sp->regExp = NULL;
  sp->redirect = NULL;
  sp->options = 0;
  sp->time = NULL;
  sp->within = UFDB_ACL_NONE;
  sp->rewrite = NULL;
  sp->nblocks = 0;
  sp->cse = NULL;
  sp->cse2 = NULL;
  sp->next = NULL;

  if (Cat == NULL) {
    Cat = sp;
    lastCat = sp;
  } else {
    lastCat->next = sp;
    lastCat = sp;
  }
}


void ufdbCategoryEnd( void )
{
  struct Category * d;
 
  d = lastCat;
  if (d->domainlist == NULL  &&  d->expressionlist == NULL  && 
      d->redirect == NULL  &&  d->rewrite == NULL  &&
      d->options == 0)
  {
    ufdbLogError( "category \"%s\" is missing content, set inactive  *****", d->name );
    d->time = NULL;
    d->active = 0;
  }
}


void ufdbCategoryOption( int value, int option )
{
   struct Category * sp;

   sp = lastCat;
   if (value)
      sp->options = sp->options | option;
   else
      sp->options = sp->options & (~option);

   if (option == UFDB_OPT_HTTPS_WITH_HOSTNAME)
      UFDBglobalHttpsWithHostname = value;
   else if (option == UFDB_OPT_HTTPS_OFFICAL_CERTIFICATE)
      UFDBglobalHttpsOfficialCertificate = value;
   else if (option == UFDB_OPT_SKYPE_OVER_HTTPS)
      UFDBglobalSkypeOverHttps = value;
   else if (option == UFDB_OPT_GTALK_OVER_HTTPS)
      UFDBglobalGtalkOverHttps = value;
   else if (option == UFDB_OPT_YAHOOMSG_OVER_HTTPS)
      UFDBglobalYahooMsgOverHttps = value;
   else if (option == UFDB_OPT_AIM_OVER_HTTPS)
      UFDBglobalAimOverHttps = value;
   else if (option == UFDB_OPT_FBCHAT_OVER_HTTPS)
      UFDBglobalFBchatOverHttps = value;
   else if (option == UFDB_OPT_CITRIXONLINE_OVER_HTTPS)
      UFDBglobalCitrixOnlineOverHttps = value;
   else if (option == UFDB_OPT_PROHIBIT_INSECURE_SSLV2)
      UFDBglobalHttpsNoSSLv2 = value;
   else if (option == UFDB_OPT_UNKNOWN_PROTOCOL_OVER_HTTPS)
      UFDBglobalUnknownProtocolOverHttps = value;
   else if (option == UFDB_OPT_SAFE_SEARCH)
      ;
   else if (option == UFDB_OPT_YOUTUBE_EDUFILTER)
      ;
   else
      ufdbLogError( "ufdbCategoryOption: unrecognised option %d *****", option );

   if (UFDBglobalDebug)
      ufdbLogMessage( "ufdbCategoryOption: %s: option %d set to %d", sp->name, option, value );
}


void ufdbCategoryDomainList( 
  char * domainlist )
{
  struct Category * sp;
  char * dbhome;
  char * dl = domainlist;
  char * name;

#if defined(UFDB_DEBUG)
   ufdbLogMessage( "ufdbCategoryDomainList %s", domainlist );
#endif

  if (UFDBglobalTerminating)
     return;

  dbhome = ufdbSettingGetValue("dbhome");
  sp = lastCat;
  if (dbhome == NULL)
    dbhome = DEFAULT_DBHOME;

  if (domainlist == NULL)
  {
    name = sp->name;
    dl = (char *) ufdbMalloc( sizeof("/dest/") + strlen(name) + sizeof("/domainlist") + 2 );
    strcpy(dl,"/dest/");
    strcat(dl,name);
    strcat(dl,"/domainlist");

    sp->domainlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(dl) + 2 );
    strcpy(sp->domainlist,dbhome);
    strcat(sp->domainlist,"/");
    strcat(sp->domainlist,dl);
  }
  else
  {
    if (domainlist[0] == '/') 
      sp->domainlist = domainlist;
    else
    {
       sp->domainlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(domainlist) + 2 );
       strcpy( sp->domainlist, dbhome );
       strcat( sp->domainlist, "/" );
       strcat( sp->domainlist, domainlist );
       ufdbFree( domainlist );
    }
  }

  sp->domainlistDb = (struct sgDb *) ufdbCalloc( 1, sizeof(struct sgDb) );
  sp->domainlistDb->type = SGDBTYPE_DOMAINLIST;
  sgDbInit( sp->domainlistDb, sp->domainlist );
  ufdbLogMessage( "loading URL table from \"%s\"", sp->domainlist );
  if (sp->domainlistDb->dbcp == NULL  ||
      ((struct UFDBmemTable *) sp->domainlistDb->dbcp)->table.nNextLevels == 0)
  {
    ufdbLogError( "URL database table \"%s\" is empty and is ignored   *****", sp->domainlist );
    ufdbFreeDomainDb( sp->domainlistDb );
    sp->domainlistDb = NULL;
  }
}


void ufdbCategoryExecDomainList( 
   char * command )
{
   struct Category * sp;

   if (UFDBglobalTerminating)
      return;

#if defined(UFDB_DEBUG)
   ufdbLogMessage( "ufdbCategoryExecDomainList %s", command );
#endif

   sp = lastCat;

   if (sp == NULL)
   {
      ufdbLogFatalError( "execdomainlist is not within a URL category" );
      return;
   }
   sp->execdomainlist = command;

   if (UFDBglobalDebug)
      ufdbLogMessage( "execdomainlist for category %s: \"%s\"", sp->name, command );
}


void ufdbFreeDomainDb( 
   struct sgDb * dbp )
{
   struct UFDBmemTable * mt;

   if (dbp == NULL)
      return;

   mt = (struct UFDBmemTable *) dbp->dbcp;
   if (mt != NULL)
   {
      if (mt->index != NULL)
	 ufdbFree( mt->index );				/* version 2.x */
      else
	 UFDBfreeTableIndex_1_2( &(mt->table) ); 	/* version 1.2 */
      ufdbFree( (void *) mt->mem );
   }
   ufdbFree( mt );
   ufdbFree( dbp );
}


void ufdbFreeIpList( struct Ip * p )
{
   struct Ip * tmp;

   while (p != NULL)
   {
      ufdbFree( p->str );
      tmp = p->next;
      ufdbFree( p );
      p = tmp;
   }
}


void ufdbFreeSourceList( struct Source * p )
{
   struct Source * tmp;

   while (p != NULL)
   {
      ufdbFreeIpList( p->ip );
      ufdbFree( p->name );
      if (p->domainDb != NULL)
	 UFDBmemDBdeleteDB( (struct UFDBmemDB *) p->domainDb );
      if (p->userDb != NULL)
      {
	 UFDBmemDBdeleteDB( (struct UFDBmemDB *) p->userDb->dbcp );
	 ufdbFree( p->userDb );
      }
      ufdbFree( p->sarg0 );

      tmp = p->next;
      ufdbFree( p );
      p = tmp;
   }
}


void ufdbFreeAclCategoryList( struct AclCategory * p )
{
   struct AclCategory * tmp;

   while (p != NULL)
   {
      ufdbFree( p->name );
      tmp = p->next;
      ufdbFree( p );
      p = tmp;
   }
}


void ufdbFreeAclList( struct Acl * p )
{
   struct Acl * tmp;

   while (p != NULL)
   {
      ufdbFree( p->name );
      ufdbFreeAclCategoryList( p->pass );
      ufdbFree( p->redirect );
      tmp = p->next;
      ufdbFree( p );
      p = tmp;
   }
}


void ufdbFreeSettingList( struct ufdbSetting * p )
{
   struct ufdbSetting * tmp;
 
   while (p != NULL)
   {
      ufdbFree( p->name );
      ufdbFree( p->value );
      tmp = p->next;
      ufdbFree( p );
      p = tmp;
   }
}


static void ufdbFreeCategoryDomainList( struct Category * p )
{
   struct Category * tmp;

   while (p != NULL)
   {
      ufdbFree( p->name );
      ufdbFree( p->domainlist );
      ufdbFreeDomainDb( p->domainlistDb );
      ufdbFree( p->execdomainlist );
      ufdbFree( p->cse );
      ufdbFree( p->cse2 );
      ufdbFree( p->expressionlist );
      ufdbFreeRegExprList( p->regExp );
      ufdbFree( p->redirect );
      ufdbFree( p->rewrite );
      tmp = p->next;
      ufdbFree( p );
      p = tmp;
   }
}


void ufdbFreeRewriteList( 
   struct sgRewrite * p )
{
   struct sgRewrite * tmp;

   while (p != NULL)
   {
      ufdbFreeRegExprList( p->rewrite );
      ufdbFree( p->name );
      tmp = p->next;
      ufdbFree( p );
      p = tmp;
   }
}


void ufdbFreeTimeElement( 
   struct TimeElement * p )
{
   struct TimeElement * tmp;

   while (p != NULL)
   {
      tmp = p->next;
      ufdbFree( p );
      p = tmp;
   }
}


void ufdbFreeTime( 
   struct ufdbTime * p )
{
   struct ufdbTime * tmp;

   while (p != NULL)
   {
      ufdbFree( p->name );
      ufdbFreeTimeElement( p->element );
      tmp = p->next;
      ufdbFree( p );
      p = tmp;
   }
}


void ufdbFreeAllMemory( void )
{
#if 0
   /* we cannot stop using the log file. we never close it */
   if (UFDBglobalLogDir != NULL)
      ufdbFree( UFDBglobalLogDir );
   UFDBglobalLogDir = NULL;
   globalLogFile = NULL;
#endif

   if (UFDBglobalEmailServer != NULL)
   {
      ufdbFree( UFDBglobalEmailServer );
      UFDBglobalEmailServer = NULL;
   }
   if (UFDBglobalAdminEmail != NULL)
   {
      ufdbFree( UFDBglobalAdminEmail );
      UFDBglobalAdminEmail = NULL;
   }
   if (UFDBglobalExternalStatusCommand != NULL)
   {
      ufdbFree( UFDBglobalExternalStatusCommand );
      UFDBglobalExternalStatusCommand = NULL;
   }

   ufdbFreeSettingList( Setting );
   ufdbFreeRewriteList( Rewrite );
   ufdbFreeCategoryDomainList( Cat );
   ufdbFreeAclList( AclList );

   ufdbFreeSourceList( (struct Source *) SourceList );
   UFDBsetSourceList( NULL );
   lastSource = NULL;

   /* free UFDBglobalCheckedDB */
   if (UFDBglobalCheckedDB.table.nNextLevels > 0  &&  UFDBglobalCheckedDB.mem != NULL)
   {
      if (UFDBglobalCheckedDB.index != NULL)
         ufdbFree( (void *) UFDBglobalCheckedDB.index );
      else
	 UFDBfreeTableIndex_1_2( &(UFDBglobalCheckedDB.table) ); 		/* .nextLevel[0]) ); */
      ufdbFree( (void *) UFDBglobalCheckedDB.mem );
   }
   UFDBglobalCheckedDB.table.nNextLevels = 0;
   UFDBglobalCheckedDB.mem = NULL;
   UFDBglobalCheckedDB.index = NULL;

   if (UFDBglobalCheckedExpressions != NULL)
   {
      ufdbFreeRegExprList( UFDBglobalCheckedExpressions );
      UFDBglobalCheckedExpressions = NULL;
   }

   lastSetting = NULL;
   Setting = NULL;

   lastCat = NULL;
   Cat = NULL;

   lastRewrite = NULL;
   Rewrite = NULL;
   lastRewriteRegExec = NULL;

   ufdbFreeTime( TimeList );
   TimeList = NULL;
   lastTime = NULL;

   ufdbFree( TimeElementsEvents );
   TimeElementsEvents = NULL;
   numTimeElements = 0;

   lastTimeElement = NULL;
   TimeElement = NULL;

   lastAcl = NULL;
   defaultAcl = NULL;
   AclList = NULL;
   lastAclCategory = NULL;

   lastRegExpDest = NULL;

   ufdbFree( UFDBglobalSquidVersion );
   UFDBglobalSquidVersion = NULL;
}


void ufdbCategoryUrlList( 
   char * urllist )
{
   if (urllist == NULL)
      urllist = "-";
   ufdbLogError( "line %d: \"urllist %s\" is deprecated and ignored *****\n"
                 "ufdbGenTable should be called with the -u option to include URLs",
		 lineno, urllist );
   if (urllist[0] != '-')
      ufdbFree( urllist );
}


void ufdbCategoryExpressionList( 
  char * exprlist, 
  char * chcase  )
{
  FILE * fp;
  char * dbhome;
  char * dl;
  char * name;
  char * p;
  int    flags;
  struct stat         statbuf;
  struct Category *   sp;
  struct ufdbRegExp * regexp;
  char   buf[UFDB_MAX_URL_LENGTH];
  char   errbuf[256];

#if defined(UFDB_DEBUG)
   ufdbLogMessage( "ufdbCategoryExpressionList %s", exprlist );
#endif

  if (UFDBglobalTerminating)
     return;

  flags = REG_EXTENDED | REG_NOSUB;
  dbhome = ufdbSettingGetValue( "dbhome" );
  sp = lastCat;
  if (dbhome == NULL)
    dbhome = DEFAULT_DBHOME;

  if (exprlist == NULL)
  {
    name = sp->name;
    dl = (char *) ufdbMalloc( sizeof("/dest/") + strlen(name) + sizeof("/expressionlist") + 2 );
    strcpy(dl,"/dest/");
    strcat(dl,name);
    strcat(dl,"/expressionlist");

    flags |= REG_ICASE; 	/* default case insensitive */

    sp->expressionlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(dl) + 2 );
    strcpy(sp->expressionlist,dbhome);
    strcat(sp->expressionlist,"/");
    strcat(sp->expressionlist,dl);
  }
  else
  {
    if (exprlist[0] == '/') 
    {
      sp->expressionlist = exprlist;
    }
    else
    {
       sp->expressionlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(exprlist) + 2 );
       strcpy( sp->expressionlist, dbhome );
       strcat( sp->expressionlist, "/" );
       strcat( sp->expressionlist, exprlist );
       ufdbFree( exprlist );
    }
    if (*chcase == 'i')
       flags |= REG_ICASE;     /* set case insensitive */
  }

  ufdbLogMessage( "loading regular expressions from \"%s\"", sp->expressionlist );

  if ((fp = fopen(sp->expressionlist, "r")) == NULL) 
  {
    ufdbLogFatalError( "cannot open expression list %s: %s", sp->expressionlist, strerror(errno) );
    return;
  }

  if (0 == fstat( fileno(fp), &statbuf ))
  {
     if (!S_ISREG(statbuf.st_mode))
     {
        ufdbLogFatalError( "expression list %s: not a regular file", sp->expressionlist );
	fclose( fp );
	return;
     }
  }

  while (!feof(fp)  &&  fgets(buf, sizeof(buf), fp) != NULL) 
  {
    if (buf[0] == '#')
       continue;

    p = (char *) strchr( buf, '\n' );
    if (p != NULL  &&  p != buf) 
    {
      if (*(p-1) == '\r') 	/* removing ^M  */
	p--;
      *p = '\0';
    }
    /* TODO: warn about leading and trailing spaces */
    regexp = ufdbNewPatternBuffer( buf, flags );
    if (regexp->error) 
    {
      regerror( regexp->error, regexp->compiled, errbuf, sizeof(errbuf) );
      ufdbLogError( "regular expression error in %s:\n%s: %s   *****", sp->expressionlist, errbuf, buf );
    }
    if (lastCat->regExp == NULL) 
    {
      lastCat->regExp = regexp;
      lastRegExpDest = regexp;
    }
    else
    {
      lastRegExpDest->next = regexp;
      lastRegExpDest = regexp;
    }
  }

  fclose( fp );

  if (UFDBglobalExpressionOptimisation)
     lastCat->regExp = UFDBoptimizeExprList( sp->expressionlist, lastCat->regExp );
}


void ufdbCategoryCACertsFile(
   char *              cacertsFile )
{
   struct Category *   cat;

   cat = lastCat;
   if (cat == NULL  ||  strcmp( cat->name, "security" ) != 0)
   {
      ufdbLogFatalError( "cacerts can only be defined inside the \"security\" category" );
      return;
   }

   cat->cse = cacertsFile;
   if (*cacertsFile == '/')
      strcpy( UFDBglobalCAcertsFile, cacertsFile );
   else
   {
      char * dbh;
      dbh = ufdbSettingGetValue( "dbhome" );
      if (dbh == NULL)
         dbh = DEFAULT_DBHOME;
      strcpy( UFDBglobalCAcertsFile, dbh );
      strcat( UFDBglobalCAcertsFile, "/" );
      strcat( UFDBglobalCAcertsFile, cacertsFile );
   }
}


void ufdbCategoryCACertsDir(
   char *              cacertsDir )
{
   struct Category *   cat;

   cat = lastCat;
   if (cat == NULL  ||  strcmp( cat->name, "security" ) != 0)
   {
      ufdbLogFatalError( "cacerts-dir can only be defined inside the \"security\" category" );
      return;
   }

   cat->cse2 = cacertsDir;
   if (*cacertsDir == '/')
      strcpy( UFDBglobalCAcertsDir, cacertsDir );
   else
   {
      char * dbh;
      dbh = ufdbSettingGetValue( "dbhome" );
      if (dbh == NULL)
        dbh = DEFAULT_DBHOME;
      strcpy( UFDBglobalCAcertsDir, dbh );
      strcat( UFDBglobalCAcertsDir, "/" );
      strcat( UFDBglobalCAcertsDir, cacertsDir );
   }
}


void ufdbCategoryRedirect( 
   char * value )
{
   struct Category * sp;

#if defined(UFDB_DEBUG)
   ufdbLogMessage( "ufdbCategoryRedirect %s", value );
#endif

   sp = lastCat;
   sp->redirect = value;
   /* TODO: check that "localhost" is not here if no 302 is used */
}


void ufdbCategoryRewrite( 
  char *              value )
{
  struct sgRewrite *  rewrite;

  if ((rewrite = sgRewriteFindName(value)) == NULL)
  {
    ufdbLogFatalError( "line %d: rewrite %s is not defined in configuration file %s",
		       lineno, value, UFDBglobalConfigFile );
    return;
  }

  lastCat->rewrite = rewrite;
}


void ufdbCategoryTime(  
  char *        name, 
  int  		within )
{
  struct ufdbTime * t;

  if ((t = sgTimeFindName(name)) == NULL) 
  {
    ufdbLogFatalError( "line %d: time \"%s\" is not defined in configuration file %s",
		       lineno, name, UFDBglobalConfigFile );
    ufdbFree( name );
    return;
  }

  lastCat->within = within;
  lastCat->time = t;
  ufdbFree( name );
}


struct Category * ufdbCategoryFindName( 
  char *               name )
{
  struct Category * p;

  for (p = Cat; p != NULL; p = p->next)
  {
    if (strcmp(name,p->name) == 0)
      return p;
  }

  return NULL;
}


void sgRewrite( 
  char * rewrite )
{
  struct sgRewrite * rew;

#if defined(UFDB_DEBUG)
   ufdbLogMessage( "sgRewrite %s", rewrite );
#endif

  if (Rewrite != NULL)
  {
    if ((struct sgRewrite *) sgRewriteFindName(rewrite) != NULL)
    {
      ufdbLogFatalError( "line %d: rewrite \"%s\" is not defined in configuration file %s",
		       lineno, rewrite, UFDBglobalConfigFile );
      ufdbFree( rewrite );
      return;
    }
  }

  rew = (struct sgRewrite *) ufdbMalloc( sizeof(struct sgRewrite) );
  rew->name = rewrite;
  rew->active = 1;
  rew->rewrite = NULL;
  rew->time = NULL;
  rew->within = UFDB_ACL_NONE;
  rew->next = NULL;

  if (Rewrite == NULL) 
  {
    Rewrite = rew;
    lastRewrite = rew;
  }
  else
  {
    lastRewrite->next = rew;
    lastRewrite = rew;
  }
}


void sgRewriteTime( 
  char * name, 
  int    within )
{
  struct ufdbTime * t;

#if defined(UFDB_DEBUG)
   ufdbLogMessage( "sgRewriteTime %s %d", name, within );
#endif

  if ((t = sgTimeFindName(name)) == NULL)
  {
    ufdbLogFatalError( "line %d: time \"%s\" is not defined in configuration file %s",
		       lineno, name, UFDBglobalConfigFile );
    ufdbFree( name );
    return;
  }

  lastRewrite->within = within;
  lastRewrite->time = t;
  ufdbFree( name );
}


void sgRewriteSubstitute( 
  char * string )
{
  char * pattern; 
  char * subst = NULL;
  char * p;
  int    flags = REG_EXTENDED;
  int    global = 0;
  char * httpcode = NULL;
  struct ufdbRegExp * regexp;
  char   errbuf[256];

  pattern = string + 2; 	/* skipping s@ */
  p = pattern;
  while ((p = strchr(p,'@')) != NULL)
  {
    if (*(p - 1) != '\\') 
    {
      *p = '\0';
      subst = p + 1;
      break;
    }
    p++;
  }

  p = strrchr( subst, '@' );
  while (p != NULL  &&  *p != '\0')
  {
    if (*p == 'r' )
      httpcode =  REDIRECT_TEMPORARILY;
    if (*p == 'R' )
      httpcode =  REDIRECT_PERMANENT;
    if (*p == 'i' || *p == 'I')
      flags |= REG_ICASE;
    if (*p == 'g')
      global = 1;
    *p = '\0'; 		/* removes @i from string */
    p++;
  } 

  regexp = ufdbNewPatternBuffer( pattern, flags );
  if (regexp->error) 
  {
      regerror( regexp->error, regexp->compiled, errbuf, sizeof(errbuf) );
      ufdbLogError( "line %d: regular expression error in %s:\n%s   *****", lineno, pattern, errbuf );
  }
  else {
    regexp->substitute = ufdbStrdup( subst );
  }

  if (lastRewrite->rewrite == NULL)
    lastRewrite->rewrite = regexp;
  else 
    lastRewriteRegExec->next = regexp;
  regexp->httpcode = httpcode;
  regexp->global = global;
  lastRewriteRegExec = regexp;
}


struct sgRewrite * sgRewriteFindName( 
  char * name )
{
  struct sgRewrite * p;

  for (p = Rewrite; p != NULL; p = p->next)
  {
    if (strcmp(name,p->name) == 0)
      return p;
  }

  return NULL;
}


/*
 * Time functions
 */

/*
 * sgTime - parse configuration time statement.
 */
void sgTime( 
  char *        name )
{
  struct ufdbTime * t;

  if (UFDBglobalDebug)
     ufdbLogMessage( "sgTime %s", name );

  if (TimeList != NULL)
  {
    if ((struct ufdbTime *) sgTimeFindName(name) != NULL)
    {
      ufdbLogFatalError( "line %d: time \"%s\" is not defined in configuration file %s",
		         lineno, name, UFDBglobalConfigFile );
      ufdbFree( name );
      return;
    }
  }
  else 
    numTimeElements = 0;

  t = (struct ufdbTime *) ufdbMalloc( sizeof(struct ufdbTime) );
  t->name = name;
  t->active = 1;
  t->element = NULL;
  t->next = NULL;

  TimeElement = NULL;
  lastTimeElement = NULL;
  if (TimeList == NULL) 
  {
    TimeList = t;
    lastTime = t;
  }
  else
  {
    lastTime->next = t;
    lastTime = t;
  }
}


/*
 * sgTimeElementInit - initialise parsing of a configuration time element.
 */
void sgTimeElementInit( void )
{
   struct TimeElement * te;

   te = (struct TimeElement *) ufdbCalloc( 1, sizeof(struct TimeElement) );
   numTimeElements++;

   if (lastTime->element == NULL)
     lastTime->element = te;
   if (lastTimeElement != NULL)
     lastTimeElement->next = te;
   lastTimeElement = te;
}


/*
 * sgTimeElementEnd - finalise parsing of configuration time element.
 */
void sgTimeElementEnd( void )
{
  time_switch = 0;
  date_switch = 0;

  if (lastTimeElement->fromdate != 0)
  {
    if (lastTimeElement->todate == 0)
      lastTimeElement->todate = lastTimeElement->fromdate + 86399;
    else 
      lastTimeElement->todate = lastTimeElement->todate + 86399;
  }

  if (lastTimeElement->from == 0  &&  lastTimeElement->to == 0)
    lastTimeElement->to = 1439;  /* set time to 23:59 */
}


/*
 * sgTimeElementAdd - add configuration time element.
 */
void sgTimeElementAdd( 
  char * element, 
  char   type ) 
{
  struct TimeElement * te;
  char * p;
  char   wday;
  int    h, m, Y, M, D;
  time_t sec;
  char * lineptr;

  wday = 0;
  M = 0;
  D = -1;
  te = lastTimeElement;

  switch (type)
  {
  case T_WEEKDAY:
    p = strtok_r( element, " \t,", &lineptr );
    do {
      if (*p == '*') {
	wday = 0x7F;
      } else if (!strncmp(p,"sun",3)) {
	wday = wday | 0x01;
      } else if (!strncmp(p,"mon",3)) {
	wday = wday | 0x02;
      } else if (!strncmp(p,"tue",3)) {
	wday = wday | 0x04;
      } else if (!strncmp(p,"wed",3)) {
	wday = wday | 0x08;
      } else if (!strncmp(p,"thu",3)) {
	wday = wday | 0x10;
      } else if (!strncmp(p,"fri",3)) {
	wday = wday | 0x20;
      } else if (!strncmp(p,"sat",3)) {
	wday = wday | 0x40;
      }
      p = strtok_r( NULL, " \t,", &lineptr );
    } while (p != NULL);
    te->wday = wday;
    break;

  case T_TVAL:
    h = -1;
    m = -1;
    sscanf( element, "%d:%d", &h, &m );
    if ((h < 0 || h > 24) || (m < 0 || m > 59))
    {
      ufdbLogFatalError( "line %d: time format error in %s", lineno, UFDBglobalConfigFile );
      h = 0;
      m = 0;
    }
    if (time_switch == 0) 
    {
      time_switch++;
      te->from = (h * 60) + m ;
    }
    else
    {
      time_switch = 0;
      te->to = (h * 60) + m ;
    }
    break;

  case T_DVAL:
    sec = date2sec( element );
    if (sec == -1) 
    {
      ufdbLogFatalError( "line %d: date format error in %s", lineno, UFDBglobalConfigFile );
      sec = 1;
    }
    if (date_switch == 0) {
      date_switch++;
      te->fromdate = sec;
    } else {
      date_switch = 0;
      te->todate = sec;
    }
    break;

  case T_DVALCRON:
    p = strtok_r( element, "-./", &lineptr );
    Y = atoi(p);
    if (*p == '*')
      Y = -1;
    else
      Y = atoi(p);
    while ((p=strtok_r(NULL,"-./",&lineptr)) != NULL) 
    {
      if (*p == '*')
	if (M == 0)
	  M = -1;
	else 
	  D = -1;
      else
	if (M == 0)
	  M = atoi(p);
	else
	  D = atoi(p);
    }
    te->y = Y;
    te->m = M;
    te->d = D;
    break;

  case T_WEEKLY:
    p = element;
    while (*p != '\0') 
    {
      switch (*p) {
      case 'S':
      case 's':
	wday = wday | 0x01;
	break;
      case 'M':
      case 'm':
	wday = wday | 0x02;
	break;
      case 'T':
      case 't':
	wday = wday | 0x04;
	break;
      case 'W':
      case 'w':
	wday = wday | 0x08;
	break;
      case 'H':
      case 'h':
	wday = wday | 0x10;
	break;
      case 'F':
      case 'f':
	wday = wday | 0x20;
	break;
      case 'A':
      case 'a':
	wday = wday | 0x40;
	break;
      default:
	ufdbLogFatalError( "line %d: weekday format error in %s", lineno, UFDBglobalConfigFile );
	break;
      }
      p++;
    }
    te->wday = wday;
    break;
  }

  ufdbFree( element );
}


/* 
 * lookup a ufdbTime element by name.
 */
struct ufdbTime * sgTimeFindName( 
  char *        name )
{
  struct ufdbTime * p;

  for (p = TimeList; p != NULL; p = p->next)
  {
    if (strcmp(name,p->name) == 0)
      return p;
  }

  return NULL;
}


/*
 * sgTimeCmp - Time array sort function.
 */
static int sgTimeCmp( const void * a, const void * b )
{
   const int * aa = (const int *) a;
   const int * bb = (const int *) b;

   return *aa - *bb;
}


/*
 * getSortedTimeElementTimes - produce a sorted array of time element times
 */
static void getSortedTimeElementTimes( void )
{
   struct ufdbTime *    p;
   struct TimeElement * te;
   int                  i, j;
   int                  totalNumElems;
 
   if (UFDBglobalDebug)
      ufdbLogMessage( "getSortedTimeElementEvents" );

   if (TimeList == NULL)
      return;

   /* find total number of time elements */
   totalNumElems = 0;
   for (p = TimeList;  p != NULL;  p = p->next) 
      for (te = p->element;  te != NULL;  te = te->next) 
         totalNumElems++;

   TimeElementsEvents = (int *) ufdbCalloc( totalNumElems * 2 , sizeof(int) ); 

   i = 0;
   for (p = TimeList;  p != NULL;  p = p->next) 
   {
      for (te = p->element;  te != NULL;  te = te->next) 
      {
         TimeElementsEvents[i++] = te->from == 0 ? 1440 : te->from;
         TimeElementsEvents[i++] = te->to == 0   ? 1440 : te->to;
      }
   }
 
   qsort( TimeElementsEvents, totalNumElems * 2, sizeof(int), sgTimeCmp );

   if (UFDBglobalDebug)
      ufdbLogMessage( "   getSortedTimeElementEvents: after qsort" );

   /* remove identical time elements */
   for (i=1,j=1;  i < totalNumElems * 2;  i++) 
   {
      if (TimeElementsEvents[i] > TimeElementsEvents[i-1])
      {
	 TimeElementsEvents[j] = TimeElementsEvents[i];
         j++;
      }
   }

   numTimeElements = j;			/* #unique time elements */
}


/*
 * _TimeEvaluateElements - evaluate all elements if they match the current time/date and mark them active.
 */
static void _TimeEvaluateElements( 
  struct tm * tm_now, 
  time_t      now )
{
  struct ufdbTime *    tlist;
  struct TimeElement * te;
  int                  min;

  if (UFDBglobalDebug)
     ufdbLogMessage( "_TimeEvaluateElements" );

  for (tlist = TimeList;  tlist != NULL;  tlist = tlist->next)
  {
    tlist->active = 0;
    for (te = tlist->element;  te != NULL;  te = te->next)
    {
      if (te->wday != 0) 			/* check wday */
      {
	if (((1 << tm_now->tm_wday) & te->wday) != 0)  
	{
	  min = (tm_now->tm_hour * 60 ) + tm_now->tm_min;
	  if (min >= te->from  &&  min < te->to) 
	  {
	    tlist->active = 1;
	    break;
	  }
	}
      }
      else if (te->fromdate != 0)		/* check date */
      {
	if (now >= te->fromdate  &&  now <= te->todate) 
	{
	  min = (tm_now->tm_hour * 60 ) + tm_now->tm_min;
	  if (min >= te->from  &&  min < te->to) 
	  {
	    tlist->active = 1;
	    break;
	  }
	}
      }
      else					/* check crondate */
      {
	if (te->y == -1  ||  te->y == (tm_now->tm_year + 1900)) 
	{
	  if (te->m == -1  ||  te->m == (tm_now->tm_mon + 1)) 
	  {
	    if (te->d == -1  ||  te->d == (tm_now->tm_mday)) 
	    {
	      min = (tm_now->tm_hour * 60 ) + tm_now->tm_min;
	      if (min >= te->from  &&  min < te->to) 
	      {
		tlist->active = 1;
		break;
	      }
	    }
	  }
	}
      }
    }
    if (UFDBglobalDebug)
       ufdbLogMessage( "      _TimeEvaluateElements: time %s is %sactive", tlist->name, tlist->active?"":"not " );
  }
}


/*
 * _TimeSetAclSrcDestRew - mark all acl/source/dest/rew (in)active.
 */
static void _TimeSetAclSrcDestRew( void )
{
  struct Acl *         acl;
  struct Category *    cat;
  struct Source *      s;
  struct sgRewrite *   rew;
  int                  a;

  if (UFDBglobalDebug)
     ufdbLogMessage( "_TimeSetAclSrcDestRew" );

  for (acl = AclList;  acl != NULL;  acl = acl->next)
  {
    if (acl->time != NULL  &&  acl->within != UFDB_ACL_ELSE) 
    {
      /* Be careful here: we are multithreaded and other threads use the value 
       * of acl->active at the same time.
       */
      a = acl->time->active;
      if (acl->within == UFDB_ACL_OUTSIDE)
	a = !a;
      if (acl->next != NULL  &&  acl->next->within == UFDB_ACL_ELSE) 
	acl->next->active = !a;
      acl->active = a;
    }
#if 0
    if (acl->pass == NULL)
       acl->active = 0;		/* it can have a 'continue' so do not make it inactive */
#endif
    if (UFDBglobalDebug)
       ufdbLogMessage( "      _TimeSetAclSrcDestRew: acl %s %s is %sactive", acl->name, 
		       acl->within==UFDB_ACL_ELSE ? "ELSE" :
			  acl->within==UFDB_ACL_WITHIN ? "WITHIN" :
			     acl->within==UFDB_ACL_OUTSIDE ? "OUTSIDE" : "",
		       acl->active?"":"not " );
  }

  for (cat = Cat;  cat != NULL;  cat = cat->next)
  {
    if (cat->time != NULL) 
    {
      cat->active = cat->time->active;
      if (cat->within == UFDB_ACL_OUTSIDE)
	cat->active = !cat->active;
    }
    if (UFDBglobalDebug)
       ufdbLogMessage( "      _TimeSetAclSrcDestRew: category %s is %sactive", cat->name, cat->active?"":"not " );
  }

  for (s = UFDBgetSourceList();  s != NULL;  s = s->next)
  {
    if (s->time != NULL) 
    {
      s->active = s->time->active;
      if (s->within == UFDB_ACL_OUTSIDE)
	s->active = !s->active;
    }
    if (UFDBglobalDebug)
       ufdbLogMessage( "      _TimeSetAclSrcDestRew: source %s is %sactive", s->name, s->active?"":"not " );
  }

  for (rew = Rewrite; rew != NULL; rew = rew->next)
  {
    if (rew->time != NULL) 
    {
      rew->active = rew->time->active;
      if (rew->within == UFDB_ACL_OUTSIDE)
	 rew->active = !rew->active;
    }
    if (UFDBglobalDebug)
       ufdbLogMessage( "      _TimeSetAclSrcDestRew: rewite %s is %sactive", rew->name, rew->active?"":"not " );
  }
}


/*
 *  ufdbHandleAlarmForTimeEvents - the alarm for the next time event went off so 
 *                                 recalculate the time-dependent active state.
 */
void ufdbHandleAlarmForTimeEvents( 
   int        why )
{
   time_t     now;
   struct tm  tm_now;
   int        m;
   int        tindex;
   int        lastval;

   if (UFDBglobalTerminating)
      return;

   if (UFDBglobalDebug)
      ufdbLogMessage( "ufdbHandleAlarmForTimeEvents" );

   if (why == UFDB_PARAM_INIT)
      ufdbLogMessage( "time definitions are used; evaluating current ACLs" );
   else
   {
      ufdbLogMessage( "alarm went off to recalculate time ACLs" );
      if (UFDBglobalTerminating)
      {
	 ufdbLogMessage( "This alarm is ignored because ufdbguardd is exiting" );
	 return;
      }
      if (UFDBglobalReconfig)
      {
	 ufdbLogMessage( "This alarm is ignored because the configuration is being reloaded"
	                 " and a new alarm is set to go off in 15 seconds" );
	 alarm( 15 );
	 return;
      }
   }

   if (TimeList == NULL)
   {
      return;
   }

   getSortedTimeElementTimes();

   now = time(NULL) + 30 + globalDebugTimeDelta;
   localtime_r( &now, &tm_now ); 
   m = (tm_now.tm_hour * 60) + tm_now.tm_min;
  
   lastval = 0;
   for (tindex = 0;  tindex < numTimeElements;  tindex++)
   {
#if UFDB_TIME_DEBUG
      if (UFDBglobalDebug)
         ufdbLogMessage( "   TimeElementsEvents[%d] = %d", tindex, TimeElementsEvents[tindex] );
#endif
      lastval = TimeElementsEvents[tindex];
      if (TimeElementsEvents[tindex] >= m)
         break;
   }

   if (UFDBglobalDebug)
      ufdbLogMessage( "   ufdbHandleAlarmForTimeEvents: m = %d  tindex = %d, lastval = %d", m, tindex, lastval );

   if (lastval < m)
      m = (((1440 - m) + TimeElementsEvents[0]) * 60) - tm_now.tm_sec;
   else
      m = ((lastval - m) * 60) - tm_now.tm_sec;

   if (m <= 0)
      m = 30;

   _TimeEvaluateElements( &tm_now, now );
   _TimeSetAclSrcDestRew();

   ufdbFree( TimeElementsEvents );
   TimeElementsEvents = NULL;

   ufdbLogMessage( "next alarm is in %d seconds", (unsigned int) m );
   ufdbSetSignalHandler( SIGALRM, sgAlarm );
   (void) alarm( (unsigned int) m );
}


/*
 * sgTimeElementClone - copy a time specification.
 */
void sgTimeElementClone( void )
{
  struct TimeElement * te;
  struct TimeElement * tmp;

  te = lastTimeElement;
  if (te == NULL) 
  {
    ufdbLogFatalError( "No previous TimeElement in sgTimeElementClone !" );
    return;
  }
  else
  {
    sgTimeElementInit();
    lastTimeElement->wday = te->wday;
    lastTimeElement->from = te->from;
    lastTimeElement->to = te->to;
    lastTimeElement->y = te->y;
    lastTimeElement->m = te->m;
    lastTimeElement->d = te->d;
    lastTimeElement->fromdate = te->fromdate;
    lastTimeElement->todate = te->todate;
    tmp = lastTimeElement;
    lastTimeElement = te;
    sgTimeElementEnd();
    lastTimeElement = tmp;
  }
}


/*
 * IP functions
 */

void sgSetIpType( 
  int         type, 
  char *      file, 
  int         line )
{
  struct Ip * ip;
  char *      p;
  char *      f;
  int         l;
  unsigned long octet;
  unsigned long op;

  ip = sgIpLast( lastSource );
  f = (file == NULL) ? UFDBglobalConfigFile : file;
  l = (line == 0) ? lineno : line;
  if (type == SG_IPTYPE_HOST)
    ip->mask = 0xffffffff;

  if (type == SG_IPTYPE_RANGE)
  {
    if (sgConvDot(ip->str,&op) == NULL)
    {
      ufdbLogFatalError( "IP address error in %s line %d", f, l );
      ip->mask = 0;
    }
    else 
      ip->mask = op;
    if ((unsigned long) ip->net > (unsigned long) ip->mask)
    {
      ufdbLogFatalError( "IP range error in %s line %d   %08lx %08lx", f, l, ip->net, (long) ip->mask );
    }
  }

  if (type == SG_IPTYPE_CLASS)
  {
    p = ip->str;
    if (*p == '/')
      p++;
    if (sgConvDot(p,&op) == NULL)
    {
      ufdbLogFatalError( "IP address error in %s line %d", f, l );
      ip->mask = 0;
    }
    else 
      ip->mask = op;
  }

  if (type == SG_IPTYPE_CIDR)
  {
    p = ip->str;
    if (*p == '/')
      p++;
    octet = (unsigned long) atoi( p );
    if (octet > 32) 
    {
      ufdbLogFatalError( "IP address CIDR out of range \"%s\" in %s line %d", p, f, l );
      octet = 32;
    }
    if (octet == 32)
      ip->mask = 0xffffffff;
    else
      ip->mask = 0xffffffff ^ (0xffffffff >> octet);
    ip->net = ip->net & ip->mask;
  }

  ip->type = type;
  ip->next = (struct Ip *) ufdbCalloc( 1, sizeof(struct Ip) );

#if 0
  ufdbLogMessage( "   sgSetIpType %2d  %08lx  %08lx", ip->type, ip->net, ip->mask );
#endif

  /* TO-DO: fix messy code where the last struct must contain zeros */
}


void sgIp( 
  char *      name )
{
  struct Ip * ip;
  ulong       op;

#if 0
  ufdbLogMessage( "   sgIp( %s )", name );
#endif

  if (lastSource->ip == NULL) 
  {
    ip = (struct Ip *) ufdbCalloc( 1, sizeof(struct Ip) );
#if 0
    ip->str = NULL;
    ip->next = NULL;
#endif
    lastSource->ip = ip;
    lastSource->lastip = ip;
  }
  else
  {
    ip = sgIpLast( lastSource );
  }

  if (ip->net_is_set == 0) 
  {
    ip->net_is_set = 1;
    if (sgConvDot(name,&op) == NULL) 
    {
      ufdbLogFatalError( "line %d: IP address error in %s", lineno, UFDBglobalConfigFile );
      ip->net = 0;
    }
    else 
      ip->net = op;
  }
  else
  {
    ip->str = ufdbStrdup( name );
  }

#if 0
  ufdbLogMessage( "   sgIp %2d  %08lx  %08lx  %s", ip->type, ip->net, ip->mask, ip->str==NULL?"NULL":ip->str );
#endif

}


struct Ip * sgIpLast( 
  struct Source * s )
{
  struct Ip * ip;
  struct Ip * last;

  last = NULL;
  for (ip = s->ip;  ip != NULL;  ip = ip->next)
    last = ip;

  return last;
}


/*
 * ACL functions
 */

void sgAcl( 
   char *          name,
   char *          value, 
   int             within )
{
   struct Acl *    acl;
   struct Source * source;

#if defined(UFDB_DEBUG)
   ufdbLogMessage( "sgAcl name=\"%s\" value=\"%s\" within=%d line=%d", 
                   name==NULL?"NULL":name,  value==NULL?"NULL":value, within, lineno );
#endif

   if (AclList != NULL) 
   {
      if (sgAclFindName(name) != NULL)
      {
	 ufdbLogFatalError( "line %d: ACL \"%s\" is already defined in configuration file %s",
			    lineno, name, UFDBglobalConfigFile );
      }
   }

  if (within == UFDB_ACL_ELSE)
  {
     if (lastAcl == NULL)
     {
        ufdbLogFatalError( "line %d: ACL \"else\" has no parent ACL", lineno );
        return;
     }
     if (name == NULL)
        name = ufdbStrdup( lastAcl->name );
  }

  acl = (struct Acl *) ufdbMalloc( sizeof(struct Acl) );

  source = NULL;
  if (strcmp(name,"default") == 0)
  {
    defaultAcl = acl;
  }
  else
  {
    if ((source = defSourceFindName(name)) == NULL)
    {
      ufdbLogFatalError( "line %d: ACL source \"%s\" is not defined in configuration file %s",
		         lineno, name, UFDBglobalConfigFile );
      ufdbFree( name );
      return;
    }
  }

  acl->name = name;
  acl->active = within == UFDB_ACL_ELSE ? 0 : 1;
  acl->source = source;
  acl->pass = NULL;
  acl->rewriteDefault = 1;
  acl->rewrite = NULL;
  acl->redirect = NULL;
  acl->time = NULL;
  acl->within = within;
  acl->next = NULL;

  if (value != NULL) 
  {
    struct ufdbTime * t;
    if ((t = sgTimeFindName(value)) == NULL) 
    {
      ufdbLogFatalError( "line %d: ACL time %s is not defined in configuration file %s",
		         lineno, value, UFDBglobalConfigFile );
      return;
    }
    acl->time = t;
  }

  if (AclList == NULL) 
  {
    AclList = acl;
    lastAcl = acl;
  }
  else
  {
    lastAcl->next = acl;
    lastAcl = acl;
  }
}


void sgAclSetValue( 
  char *               what,
  char *               value, 
  int                  allowed ) 
{
  struct Category *    dest = NULL;
  struct AclCategory * aclcat;
  int                  type;
  
#if defined(UFDB_DEBUG)
   ufdbLogMessage( "sgAclSetValue %s %s%s", what, allowed?"":"!", value );
#endif

  if (lastAcl == NULL)
  {
     ufdbLogError( "error in configuration file on line %d: cannot set value for \"%s\" because there is no defined ACL", 
                   lineno, what );
     ufdbFree( value );
     return;
  }

  type = ACL_TYPE_TERMINATOR;

  if (strcmp(what,"pass") == 0)
  {
    if (strcmp(value,"any")==0 || strcmp(value,"all")==0)
      allowed = 1;
    else if (strcmp(value,"none") == 0)
      allowed = 0;
    else if (strcmp(value,"in-addr") == 0) {
      type = ACL_TYPE_INADDR;
    }
    else
    {
      if ((dest = ufdbCategoryFindName(value)) == NULL) 
      {
	ufdbLogFatalError( "ACL category %s is not defined in configuration file %s",
			   value, UFDBglobalConfigFile );
	ufdbFree( value );
        return;
      } 
      type = ACL_TYPE_DEFAULT;
    }

    aclcat = ufdbMalloc( sizeof(struct AclCategory) );
    aclcat->name = value;
    aclcat->dest = dest;
    aclcat->access = allowed;
    aclcat->type = type;
    aclcat->nblocks = 0;
    aclcat->next = NULL;

    if (lastAcl->pass == NULL) {
      lastAcl->pass = aclcat;
    } else {
      lastAclCategory->next = aclcat;
    }
    lastAclCategory = aclcat;
  }
  else if (strcmp(what,"rewrite") == 0)
  {
    if (strcmp(value,"none") == 0)
    {
      lastAcl->rewriteDefault = 0;
      lastAcl->rewrite = NULL;
    }
    else
    {
      struct sgRewrite * rewrite;

      if ((rewrite = sgRewriteFindName(value)) == NULL) 
      {
	ufdbLogFatalError( "rewrite %s is not defined in configuration file %s",
			   value, UFDBglobalConfigFile );
      }
      lastAcl->rewriteDefault = 0;
      lastAcl->rewrite = rewrite;
    }
    ufdbFree( value );
  }
  else if (strcmp(what,"redirect") == 0)
  {
    if (strcmp(value,"default") != 0)
    {
      lastAcl->redirect = value;
    }
    else 
    {
      lastAcl->redirect = NULL;
      ufdbFree( value );
    }
  }
}


struct Acl * sgAclFindName( 
  char *       name )
{
  struct Acl * p;

  if (name == NULL)
     return NULL;

  for (p = AclList;  p != NULL;  p = p->next)
  {
    if (strcmp(name,p->name) == 0)
      return p;
  }

  return NULL;
}



/*
 * called by main loop: find the first active ACL that matches a source
 */
struct Acl * UFDBfindACLbySource( 
   struct Source * source )
{
   struct Acl *    acl;

   if (source == NULL)
   {
#ifdef UFDB_DEBUG_ACL_ACCESS
      if (UFDBglobalDebug)
#else
      if (UFDBglobalDebug > 1)
#endif
	 ufdbLogMessage( "   UFDBfindACLbySource: source=NULL returning defaultACL" );
      return defaultAcl;
   }

   for (acl = AclList;  acl != NULL;  acl = acl->next)
   {
      if (acl->source == source  &&  acl->active)
      {
#ifdef UFDB_DEBUG_ACL_ACCESS
	 if (UFDBglobalDebug)
	    ufdbLogMessage( "   UFDBfindACLbySource: active ACL for source '%s' found", source->name );
#endif
	 return acl;
      }
   }

#ifdef UFDB_DEBUG_ACL_ACCESS
   if (UFDBglobalDebug)
      ufdbLogMessage( "   UFDBfindACLbySource: no active ACL for source '%s' found, returning defaultAcl", source->name );
#endif

   return defaultAcl;
}


/*
 * called by main loop: scan the full access matrix for the URL in parameter 'req'
 * return value:
 * UFDB_ACL_ACCESS_DUNNO:  don't know.
 * UFDB_ACL_ACCESS_ALLOW:  explicit allow.
 * UFDB_ACL_ACCESS_BLOCK:  explicit block; a redirection string is returned also.
 */
int UFDBCheckACLaccess( 
  int                  reconfiguring,
  struct Acl *         acl, 
  struct SquidInfo *   si, 
  char *               redirectURL )
{
  int                  access;
  char *               redirect;
  struct sgRewrite *   rewrite = NULL;
  struct AclCategory * aclpass = NULL;
  struct Category *    category;
  char                 newstring[UFDB_MAX_URL_LENGTH];
  char                 newredir[UFDB_MAX_URL_LENGTH + UFDB_MAX_URL_LENGTH];

  si->blockReason = UFDB_API_BLOCK_NONE;
  si->aclpass = NULL;

#ifdef UFDB_DEBUG_ACL_ACCESS
   if (UFDBglobalDebug)
      ufdbLogMessage( "   UFDBCheckACLaccess :" );
#endif

  if (reconfiguring)
  {
#ifdef _POSIX_PRIORITY_SCHEDULING
    static volatile int yieldcounter = 0;
    if (++yieldcounter > 8)
    {
       yieldcounter = 0;
       sched_yield();		
    }
#endif
    si->blockReason = UFDB_API_BLOCK_LOADING_DB;
    if (UFDBglobalURLlookupResultDBreload == UFDB_DENY)
    {
       strcpy( redirectURL, UFDBglobalLoadingDatabaseRedirect );
       return UFDB_ACL_ACCESS_BLOCK;
    }
    *redirectURL = '\0';
    return UFDB_ACL_ACCESS_ALLOW;
  }

  if (UFDBglobalFatalError)
  {
    si->blockReason = UFDB_API_BLOCK_FATAL_ERROR;
    if (UFDBglobalURLlookupResultFatalError == UFDB_DENY)
    {
       strcpy( redirectURL, UFDBglobalFatalErrorRedirect );
       return UFDB_ACL_ACCESS_BLOCK;
    }
    *redirectURL = '\0';
    return UFDB_ACL_ACCESS_ALLOW;
  }

  if (acl == NULL)
  {
     if (UFDBglobalDebug)
        ufdbLogMessage( "   UFDBCheckACLaccess  acl = NULL,  return DUNNO" );
     return UFDB_ACL_ACCESS_DUNNO;
  }

  si->aclpass = NULL;
  aclpass = acl->pass;

  if (aclpass == NULL)
  {  
     /*
      * an "empty pass" was always blocked but in case of a continued search we should return DUNNO.
      */
#if 0
     if (UFDBglobalDebug > 1)
        ufdbLogMessage( "   UFDBCheckACLaccess  acl->pass NULL  acl->source %08lx  source->name '%s'  continued-search %d", 
	                (unsigned long) acl->source,
			acl->source == NULL ? "NULL" : acl->source->name,
			acl->source != NULL  &&  acl->source->cont_search );
#endif

     if (acl->source != NULL  &&  acl->source->cont_search)
     {
	if (UFDBglobalDebug)
	   ufdbLogMessage( "   UFDBCheckACLaccess  pass = NULL  continued-search 1  return DUNNO" );
        access = UFDB_ACL_ACCESS_DUNNO;
        redirect = NULL;
     }
     else
     {
	if (UFDBglobalDebug)
	   ufdbLogMessage( "   UFDBCheckACLaccess  pass = NULL  continued-search 0  return BLOCK" );
        aclpass = defaultAcl->pass;
	si->blockReason = UFDB_API_BLOCK_ACL;
	access = UFDB_ACL_ACCESS_BLOCK;
	if (defaultAcl == NULL  ||  defaultAcl->redirect == NULL)
	   redirect = "http://cgibin.urlfilterdb.com/cgi-bin/URLblocked.cgi?"
		      "clientaddr=unknown&clientname=unknown&clientuser=unknown&clientgroup=unknown&"
		      "targetgroup=nodefaultacl&url=%u";
	else
	   redirect = defaultAcl->redirect;
     }
  }
  else
  {
    access = UFDB_ACL_ACCESS_DUNNO;
    redirect = NULL;
    for ( ;  aclpass != NULL;  aclpass = aclpass->next)
    {
      category = aclpass->dest;
      if (category != NULL  &&  !category->active)
	continue;

#if defined(UFDB_DEBUG) || defined(UFDB_DEBUG_ACL_ACCESS)
      if (UFDBglobalDebug  &&  category != NULL)
	 ufdbLogMessage( "   UFDBCheckACLaccess: testing acl \"%s\" with category \"%s\"", acl->name, category->name );
#endif

      if (aclpass->type == ACL_TYPE_TERMINATOR) 
      {
        si->aclpass = aclpass;
	access = aclpass->access == 0 ? UFDB_ACL_ACCESS_BLOCK : UFDB_ACL_ACCESS_ALLOW;
	if (!aclpass->access)
	   si->blockReason = UFDB_API_BLOCK_ACL;
	break;
      }

      if (aclpass->type == ACL_TYPE_INADDR) 
      {
	si->aclpass = aclpass;
	if (si->dot) 
	{
	   access = aclpass->access == 0 ? UFDB_ACL_ACCESS_BLOCK : UFDB_ACL_ACCESS_ALLOW;
	   if (!aclpass->access)
	      si->blockReason = UFDB_API_BLOCK_ACL;
	   break;
	}
	continue;
      }

      /* domain name lookup for this source */
      if (category->domainlistDb != NULL) 
      {
	int result;
	int use_rw_lock;
        struct UFDBmemTable * mt;

        use_rw_lock = (category->execdomainlist != NULL);
	if (use_rw_lock)						/* LOCK ====================================== */
	{
	   int ret;
#ifdef UFDB_HAVE_NATIVE_RWLOCK_MUTEX
	   ret = pthread_rwlock_rdlock( &TheDynamicCategoriesLock );
	   if (ret != 0)
	      ufdbLogError( "UFDBCheckACLaccess: pthread_rwlock_rdlock TheDynamicCategoriesLock failed with code %d", ret );
#else
	   ret = pthread_mutex_lock( &TheDynamicCategoriesLock );
	   if (ret != 0)
	      ufdbLogError( "UFDBCheckACLaccess: pthread_mutex_lock TheDynamicCategoriesLock failed with code %d", ret );
#endif
        }

        mt = (struct UFDBmemTable *) category->domainlistDb->dbcp;
        result = UFDBlookupRevUrl( &(mt->table.nextLevel[0]), si->revUrl );

        if (use_rw_lock)						/* UNLOCK ==================================== */
	{
	   int ret;
#ifdef UFDB_HAVE_NATIVE_RWLOCK_MUTEX
	   ret = pthread_rwlock_unlock( &TheDynamicCategoriesLock );
	   if (ret != 0)
	      ufdbLogError( "UFDBCheckACLaccess: pthread_rwlock_unlock TheDynamicCategoriesLock failed with code %d", ret );
#else
	   ret = pthread_mutex_unlock( &TheDynamicCategoriesLock );
	   if (ret != 0)
	      ufdbLogError( "UFDBCheckACLaccess: pthread_mutex_unlock TheDynamicCategoriesLock failed with code %d", ret );
#endif
        }

	if (result)
	{
#ifdef UFDB_DEBUG_ACL_ACCESS
	  if (UFDBglobalDebug)
	    ufdbLogMessage( "   UFDBCheckACLaccess: acl \"%s\" with category \"%s\": UFDBlookupRevUrl  returned a match", 
	                    acl->name, category->name  );
#endif
	  si->blockReason = UFDB_API_BLOCK_ACL;
	  si->aclpass = aclpass;
	  access = aclpass->access == 0 ? UFDB_ACL_ACCESS_BLOCK : UFDB_ACL_ACCESS_ALLOW;
	  break;
	}
      }

      if (si->dot  &&
          (si->port == 443  ||  si->port == 563  ||  strcmp( si->method, "CONNECT" ) == 0  ||  strcmp( si->protocol, "https" ) == 0) )
      {
	 if (category->name != NULL  &&  strcmp( category->name, "security" ) == 0)
	 {
	    int httpsStatus;

	    /* We MUST verify for Skype without queueing since if the connection is a valid Skype 
	     * it might otherwise be blocked due to the UFDB_OPT_HTTPS_WITH_HOSTNAME option.
	     * This is known to slow down connections to HTTPS-based URLs with an IP address.
	     */
	    httpsStatus = UFDBcheckForHTTPStunnel( si->orig_domain, si->port, 0 );

	    if (UFDBglobalDebug || UFDBglobalDebugSkype || UFDBglobalDebugGtalk || UFDBglobalDebugYahooMsg || 
	        UFDBglobalDebugAim || UFDBglobalDebugFBchat || UFDBglobalDebugCitrixOnline )
	    {
	       ufdbLogMessage( "      HTTPS protocol check for %s:%d returned status = %d/%s", 
			       si->orig_domain, si->port, httpsStatus, ufdbAPIstatusString(httpsStatus) );
	    }

	    if (httpsStatus == UFDB_API_ERR_SOCKET)
	    {
	       si->blockReason = UFDB_API_BLOCK_HTTPS_OPTION;
	       si->aclpass = aclpass;
	       return UFDB_ACL_ACCESS_ALLOW;
	    }

	    if (httpsStatus == UFDB_API_ERR_IS_SKYPE)
	    {
	       if (UFDBglobalDebug || UFDBglobalDebugSkype)
	       {
	          if (UFDBglobalSkypeOverHttps)
		     ufdbLogMessage( "   UFDBCheckACLaccess  Skype detected, return ALLOW" );
		  else
		     ufdbLogMessage( "   UFDBCheckACLaccess  Skype detected, return BLOCK" );
	       }
	       si->blockReason = UFDB_API_BLOCK_HTTPS_OPTION;
	       si->aclpass = aclpass;
	       access = UFDBglobalSkypeOverHttps ? UFDB_ACL_ACCESS_ALLOW : UFDB_ACL_ACCESS_BLOCK;
	       break;
	    }

	    if (httpsStatus == UFDB_API_ERR_IS_GTALK)
	    {
	       if (UFDBglobalDebug || UFDBglobalDebugGtalk)
	       {
	          if (UFDBglobalGtalkOverHttps)
		     ufdbLogMessage( "   UFDBCheckACLaccess  Google Talk detected, return ALLOW" );
		  else
		     ufdbLogMessage( "   UFDBCheckACLaccess  Google Talk detected, return BLOCK" );
	       }
	       si->blockReason = UFDB_API_BLOCK_HTTPS_OPTION;
	       si->aclpass = aclpass;
	       access = UFDBglobalGtalkOverHttps ? UFDB_ACL_ACCESS_ALLOW : UFDB_ACL_ACCESS_BLOCK;
	       break;
	    }

	    if (httpsStatus == UFDB_API_ERR_IS_YAHOOMSG)
	    {
	       if (UFDBglobalDebug || UFDBglobalDebugYahooMsg)
	       {
	          if (UFDBglobalYahooMsgOverHttps)
		     ufdbLogMessage( "   UFDBCheckACLaccess  Yahoo IM detected, return ALLOW" );
		  else
		     ufdbLogMessage( "   UFDBCheckACLaccess  Yahoo IM detected, return BLOCK" );
	       }
	       si->blockReason = UFDB_API_BLOCK_HTTPS_OPTION;
	       si->aclpass = aclpass;
	       access = UFDBglobalYahooMsgOverHttps ? UFDB_ACL_ACCESS_ALLOW : UFDB_ACL_ACCESS_BLOCK;
	       break;
	    }

	    if (httpsStatus == UFDB_API_ERR_IS_AIM)
	    {
	       if (UFDBglobalDebug || UFDBglobalDebugAim)
	       {
	          if (UFDBglobalAimOverHttps)
		     ufdbLogMessage( "   UFDBCheckACLaccess  AIM detected, return ALLOW" );
		  else
		     ufdbLogMessage( "   UFDBCheckACLaccess  AIM detected, return BLOCK" );
	       }
	       si->blockReason = UFDB_API_BLOCK_HTTPS_OPTION;
	       si->aclpass = aclpass;
	       access = UFDBglobalAimOverHttps ? UFDB_ACL_ACCESS_ALLOW : UFDB_ACL_ACCESS_BLOCK;
	       break;
	    }

	    if (httpsStatus == UFDB_API_ERR_IS_FBCHAT)
	    {
	       if (UFDBglobalDebug || UFDBglobalDebugFBchat)
	       {
	          if (UFDBglobalFBchatOverHttps)
		     ufdbLogMessage( "   UFDBCheckACLaccess  Facebook Chat detected, return ALLOW" );
		  else
		     ufdbLogMessage( "   UFDBCheckACLaccess  Facebook Chat detected, return BLOCK" );
	       }
	       si->blockReason = UFDB_API_BLOCK_HTTPS_OPTION;
	       si->aclpass = aclpass;
	       access = UFDBglobalFBchatOverHttps ? UFDB_ACL_ACCESS_ALLOW : UFDB_ACL_ACCESS_BLOCK;
	       break;
	    }

	    if (httpsStatus == UFDB_API_ERR_IS_CITRIXONLINE)
	    {
	       if (UFDBglobalDebug || UFDBglobalDebugCitrixOnline)
	       {
	          if (UFDBglobalCitrixOnlineOverHttps)
		     ufdbLogMessage( "   UFDBCheckACLaccess  CitrixOnline detected, return ALLOW" );
		  else
		     ufdbLogMessage( "   UFDBCheckACLaccess  CitrixOnline detected, return BLOCK" );
	       }
	       si->blockReason = UFDB_API_BLOCK_HTTPS_OPTION;
	       si->aclpass = aclpass;
	       access = UFDBglobalCitrixOnlineOverHttps ? UFDB_ACL_ACCESS_ALLOW : UFDB_ACL_ACCESS_BLOCK;
	       break;
	    }

	    if (httpsStatus == UFDB_API_ERR_TUNNEL)
	    {
	       if (UFDBglobalDebug || UFDBglobalDebugSkype || UFDBglobalDebugGtalk || UFDBglobalDebugYahooMsg || 
	           UFDBglobalDebugAim || UFDBglobalDebugFBchat || UFDBglobalDebugCitrixOnline)
	       {
	          ufdbLogMessage( "   UFDBCheckACLaccess  Tunnel detected, return BLOCK" );
	       }
	       si->blockReason = UFDB_API_BLOCK_HTTPS_OPTION;
	       si->aclpass = aclpass;
	       access = UFDB_ACL_ACCESS_BLOCK;
	       break;
	    }

	    if (httpsStatus == UFDB_OPT_UNKNOWN_PROTOCOL_OVER_HTTPS)
	    {
	       if (UFDBglobalDebug || UFDBglobalDebugSkype || UFDBglobalDebugGtalk || UFDBglobalDebugYahooMsg || 
	           UFDBglobalDebugAim || UFDBglobalDebugFBchat || UFDBglobalDebugCitrixOnline)
	       {
	          if (UFDBglobalUnknownProtocolOverHttps)
		     ufdbLogMessage( "   UFDBCheckACLaccess  unknown protocol detected, return ALLOW" );
		  else
		     ufdbLogMessage( "   UFDBCheckACLaccess  unknown protocol detected, return BLOCK" );
	       }
	       si->blockReason = UFDB_API_BLOCK_HTTPS_OPTION;
	       si->aclpass = aclpass;
	       access = UFDBglobalUnknownProtocolOverHttps ? UFDB_ACL_ACCESS_ALLOW : UFDB_ACL_ACCESS_BLOCK;
	       break;
	    }

	    if (category->options & UFDB_OPT_HTTPS_WITH_HOSTNAME)
	    {
	       ufdbLogError( "HTTPS protocol used to access IP %s (FQDN is required)", si->domain );
	       si->blockReason = UFDB_API_BLOCK_HTTPS_OPTION;
	       si->aclpass = aclpass;
	       access = UFDB_ACL_ACCESS_BLOCK;
	       break;
	    }
	 }
      }

      if (access == UFDB_ACL_ACCESS_DUNNO  &&
          (category->options & UFDB_OPT_HTTPS_OFFICAL_CERTIFICATE)  &&
	  (UFDBgetTunnelCheckMethod() != UFDB_API_HTTPS_CHECK_OFF)  &&
          (si->port == 443 || si->port == 563 || strcmp( si->protocol, "https" ) == 0) )
      {
         int httpsStatus;

	 httpsStatus = UFDBcheckForHTTPStunnel( si->orig_domain, si->port,
	    UFDBgetTunnelCheckMethod() == UFDB_API_HTTPS_CHECK_AGGRESSIVE ? 0 : UFDB_API_ALLOW_QUEUING );
	 if (UFDBglobalDebug)
	    ufdbLogMessage( "      HTTPS certificate check: %s:%d has status = %d/%s", 
	                    si->orig_domain, si->port, httpsStatus, ufdbAPIstatusString(httpsStatus) );
	 if (httpsStatus == UFDB_API_ERR_INVALID_CERT)
	 {
	    si->blockReason = UFDB_API_BLOCK_HTTPS_OPTION;
	    access = UFDB_ACL_ACCESS_BLOCK;
	    break;
	 }
      }

      if (access == UFDB_ACL_ACCESS_DUNNO  &&  
          (UFDBgetTunnelCheckMethod() != UFDB_API_HTTPS_CHECK_OFF)  &&  
	  (strcmp( aclpass->name, "proxies" ) == 0)  &&
          (si->port == 443 || si->port == 563 || si->port == 9001 ||
	   strcmp( si->method, "CONNECT" ) == 0  ||  strcmp( si->protocol, "https" ) == 0) )
      {
         int httpsStatus;

	 httpsStatus = UFDBcheckForHTTPStunnel( si->orig_domain, si->port,
	    UFDBgetTunnelCheckMethod() == UFDB_API_HTTPS_CHECK_AGGRESSIVE ? 0 : UFDB_API_ALLOW_QUEUING );
	 if (UFDBglobalDebug)
	    ufdbLogMessage( "      HTTPS proxy check: %s:%d has status = %d/%s",
	                    si->orig_domain, si->port, httpsStatus, ufdbAPIstatusString(httpsStatus) );
	 if (httpsStatus == UFDB_API_ERR_TUNNEL)
	 {
	    UFDBglobalTunnelCounter++;
	    if (UFDBgetTunnelCheckMethod() != UFDB_API_HTTPS_LOG_ONLY)
	    {
	       si->blockReason = UFDB_API_BLOCK_HTTPS_OPTION;
	       si->aclpass = aclpass;
	       access = UFDB_ACL_ACCESS_BLOCK;
	       break;
	    }
	 }
      }

      /* expr lookup for this source */
      if (access == UFDB_ACL_ACCESS_DUNNO  &&
          category->regExp != NULL)
      {
        int result;

	result = ufdbRegExpMatch( category->regExp, si->surl );
	if (UFDBglobalDebugRegexp)
	   ufdbLogMessage( "      expressionlist %s: ufdbRegExpMatch( %s ) : %s", 
	                   category->name,  si->surl,
			   result==0 ? "no match" : "matched" );
	if (result) 
	{
	  si->blockReason = UFDB_API_BLOCK_ACL;
	  si->aclpass = aclpass;
	  access = aclpass->access ? UFDB_ACL_ACCESS_ALLOW : UFDB_ACL_ACCESS_BLOCK;
	  break;
	}
      }

       /* per-category SafeSearch */
       if (access == UFDB_ACL_ACCESS_DUNNO  &&  
           category != NULL  &&  category->options & UFDB_OPT_SAFE_SEARCH)
       {
	   if (UFDBaddSafeSearch( si->domain, si->surl, si->orig )
		   == UFDB_API_MODIFIED_FOR_SAFESEARCH)
	   {
	      si->blockReason = UFDB_API_BLOCK_SAFESEARCH;
	      si->aclpass = aclpass;
	      strcpy( redirectURL, si->orig );
#ifdef UFDB_DEBUG_ACL_ACCESS
	      if (UFDBglobalDebug)
		 ufdbLogMessage( "   UFDBCheckACLaccess  category-specific SafeSearch returns BLOCK" );
#endif
	      return UFDB_ACL_ACCESS_BLOCK;
	   }
       }

       /* per-category EduFilter */
       if (access == UFDB_ACL_ACCESS_DUNNO  && 
           category != NULL  &&  category->options & UFDB_OPT_YOUTUBE_EDUFILTER)
       {
	   if (UFDBaddYoutubeEdufilter( si->domain, si->surl, si->orig )
		   == UFDB_API_MODIFIED_FOR_YOUTUBE_EDUFILTER)
	   {
	      si->blockReason = UFDB_API_BLOCKR_YOUTUBE_EDUFILTER;
	      si->aclpass = aclpass;
	      strcpy( redirectURL, si->orig );
#ifdef UFDB_DEBUG_ACL_ACCESS
	      if (UFDBglobalDebug)
		 ufdbLogMessage( "   UFDBCheckACLaccess  category-specific Youtube edufilter returns BLOCK" );
#endif
	      return UFDB_ACL_ACCESS_BLOCK;
	   }
       }
    }

    if (access == UFDB_ACL_ACCESS_BLOCK) 
    {
      if (category != NULL  &&  category->redirect != NULL)
	 redirect = category->redirect;
      else if (category != NULL  &&  category->rewrite != NULL  &&
	       (redirect = sgRewriteExpression(category->rewrite,si->orig,newstring)) != NULL)
      {
	 ;
      }
      else if (acl->redirect == NULL)
	 redirect = defaultAcl->redirect;
      else
	 redirect = acl->redirect;
      if (redirect == NULL)
      {
#ifdef UFDB_DEBUG_ACL_ACCESS
         /* suppress many errors. we only want it once! */
         ufdbLogError( "!!!!! there is no \"redirect\" rule for ACL %s/%s  *****", 
		       acl->name, aclpass->name );
#endif
         /* TODO: copy the redirect rule for the security or proxy category */
         /* TODO: instead of referring to cgibin.urlfilterdb.com */
         redirect = "http://cgibin.urlfilterdb.com/cgi-bin/URLblocked.cgi?"
	            "clientgroup=%s&category=%t&url=%u";
       }
     }
   }

   if (acl->rewrite == NULL)
      rewrite = defaultAcl->rewrite;
   else
      rewrite = acl->rewrite;

#if 0
   if (access == UFDB_ACL_ACCESS_BLOCK  &&  (si->port == 443  ||  strcmp(si->protocol,"https") == 0))
   {
      redirect = sgParseRedirect( UFDBglobalRedirectHttps, si, acl, aclpass, newredir, 1 );
   }
   else 
#endif

   /* There is a big challenge here for HTTPS:
    *
    * It is not desired to block CONNECT since redirecting CONNECT results in vague browser errors like "error conecting to SITE"
    * instead of a user-friendly message produced by the target URL of the URL redirector.
    *
    * If Squid is used without sslBump, the redirector only receives a CONNECT to DOMAIN:443 (e.g. c.msn.com:443 CONNECT)
    * which can be blocked/redirected and which causes vague errors for regular HTTP+SSL sites, and other errors for other
    * applications (SSH tunnel, Skype and others).
    *
    * If Squid is used with sslBump, for regular HTTP+SSL based sites the redirector receives
    *   a) CONNECT to DOMAIN:443 (e.g. c.msn.com:443 CONNECT), followed by
    *   b) the https-based URLs which we can block/redirect (e.g. https://c.msn.com/c.gif GET).
    *       NOTE that redirecting here works well and the redirected URL shows a user-friendly message 
    *       about the reason why it is blocked.
    * So for regular HTTP+SSL based sites we can PASS the CONNECT request and wait for the GET/POST/HEAD to do the 
    * postponed redirecting/blocking of (parts of) the site and this way block unwanted content without causing
    * the vague browser errors.
    * CAVEAT: if squid uses sslBump but the CONNECT is to a blocked site that has a tunnel (i.e. no GET/POST/HEAD)
    * we will never receive a GET/POST/HEAD that can be blocked !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    * So ... for proxies, tunnels, chat, adult we simply block the connect and for other URL categories we can 
    * hope that a GET/POST/HEAD will be used
    * OR: probe the website and verify is speaks SSL+HTTP, so we are 99% sure that a GET/PPOST/HEAD *will* follow.
    *
    * If Squid is used with sslBump, for sites that do not use HTTP+SSL (e.g. SSH tunnel, Skype and others), 
    * Squid tries to open a HTTP+SSL connection to verify the certificates but it receives an error opening
    * the connection.
    * the redirector receives
    *   a) only the CONNECT to DOMAIN:443 (e.g. mysshtunnel.com:443)
    * So to block Skype and other applications using HTTPS there is no other option than to
    * send a redirection URL causing an error for the application which I find acceptable.
    * Most likely the blocked application will complain with a vague error.
    *
    * The sslBump feature of Squid 3.1.19 has a nasty side-effect: for streams that are not HTTP+SSL it hangs.
    * For example, the SSH tunnel hangs (I do not understand the debug log but it does not show anything interesting)
    * To test: Skype (I assume it hangs also)
    * I do not want to test with unsafe options 'sslproxy_cert_error allow all' and
    * 'sslproxy_flags DONT_VERIFY_PEER' since these options can never be used in a production environment.
    *
    * ufdbGuard has a new option called "squid-uses-ssl-bump" to know if sslBump is used.
    * If sslBump is not used, there is no other option than to send a URL redirection causing
    * very vague browser errors for regular HTTP+SSL sites.
    *
    * If sslBump is used,
    * the challenge is to find out which forbidden sites are "regular HTTP+SSL based sites" and which are not.
    * ufdbGuard does a background probe on the sites and eventually it will be known if the blocked URL
    * belongs to a "regular HTTP+SSL based site".  The best option is to wait for the probe to finish.
    *
    * The redirector can also do a lookup. If the URL is in the ufdbsafe table, it can PASS.
    */
   if (access ==  UFDB_ACL_ACCESS_BLOCK  &&  UFDBglobalSquidUsesSSLbump)
   {
      if ((strcmp( si->method, "CONNECT" ) == 0)  &&
          (strcmp( aclpass->name, "security" ) == 0)  &&
          (si->port == 443  ||  si->port == 563  ||  strcmp( si->protocol, "https" ) == 0))
      {
	 int httpsStatus;
	 httpsStatus = UFDBcheckForHTTPStunnel( si->orig_domain, si->port, 0 );
	 if (UFDBglobalDebug)
	 {
	    ufdbLogMessage( "      ssl-bump check: %s:%d has status = %d/%s", 
	                    si->orig_domain, si->port, httpsStatus, ufdbAPIstatusString(httpsStatus) );
	 }
	 if (httpsStatus == UFDB_API_OK)	
	 {
	    /* This CONNECT should be blocked but the server has SSL+HTTP, so instead of
	     * redirecting the CONNECT resulting in an ugly message for the end user,
	     * the CONNECT is allowed and we will wait for the next GET/HEAD/POST to do
	     * a block and redirect the blocked URL to a page with an error message
	     * that the end user can understand.
	     */
	    access = UFDB_ACL_ACCESS_ALLOW;
	 }
      }
   }
   else if (access == UFDB_ACL_ACCESS_BLOCK  &&  strcmp( si->method, "CONNECT" ) == 0)
   {
      redirect = UFDBglobalRedirectHttps;
      if (UFDBglobalDebug > 1)
	 ufdbLogMessage( "CONNECT to %s:%d redirected to %s", si->orig_domain, si->port, redirect );
   }

   if (rewrite != NULL  &&  access == UFDB_ACL_ACCESS_DUNNO)
   {
      redirect = sgRewriteExpression( rewrite, si->orig, newstring );
   }
   else if (redirect != NULL) 
   {
      redirect = sgParseRedirect( redirect, si, acl, aclpass, newredir, strcmp(si->protocol,"https")==0 );
   }

   if (redirect != NULL)
   {
      strcpy( redirectURL, redirect );
      si->aclpass = aclpass;
#ifdef UFDB_DEBUG_ACL_ACCESS
      if (UFDBglobalDebug)
        ufdbLogMessage( "   UFDBCheckACLaccess  redirected, return BLOCK  redirect: %s", redirectURL );
#endif
      return UFDB_ACL_ACCESS_BLOCK;
   }

   *redirectURL = '\0';
#ifdef UFDB_DEBUG_ACL_ACCESS
   if (UFDBglobalDebug)
     ufdbLogMessage( "   UFDBCheckACLaccess  end, return %d", access );
#endif

   return access;
}


void yyerror( char * s )
{
   ufdbLogFatalError( "line %d: %s in configuration file %s", lineno, s, UFDBglobalConfigFile );
}


int yywrap()
{
  return 1;
}

